#-*- coding: utf-8 -*-

from trytond.model import ModelView, ModelSQL, fields
from trytond.pool import Pool, PoolMeta
from dateutil.relativedelta import relativedelta
from trytond.pyson import Eval


__all__ = ['PatientEvaluation']


class PatientEvaluation(ModelSQL,ModelView):
    'Patient Evaluation'
    __name__ = 'gnuhealth.patient.evaluation'
    
    STATES = {'readonly': Eval('state') == 'signed'}
    cardiovascular_risk = fields.Selection([
        (None, ''),
        ('1', 'less than 10'),
        ('2', '10-20'),
        ('3', '20-30'),
        ('4', '30-40'),
        ('5', 'more  than 40'),
        ], 'cardiovascular risk', sort=False, states = STATES)
    patient_ambulatory_care = fields.Many2One(
        'gnuhealth.patient.ambulatory_care','Atención Enfermería',                    
                    domain=[('patient','=',Eval('patient'))],
                    depends=['patient'],
                    states = STATES)

    @fields.depends('patient_ambulatory_care')
    def on_change_patient_ambulatory_care(self, name = None):                
        if self.patient_ambulatory_care:
            self.systolic = self.patient_ambulatory_care.systolic
            self.diastolic = self.patient_ambulatory_care.diastolic
            self.temperature = self.patient_ambulatory_care.temperature
            self.glycemia = self.patient_ambulatory_care.glycemia
            self.bpm =self.patient_ambulatory_care.bpm
            self.respiratory_rate = self.patient_ambulatory_care.respiratory_rate
            self.osat = self.patient_ambulatory_care.osat
            self.weight = self.patient_ambulatory_care.weight
            self.height = self.patient_ambulatory_care.height
            self.head_circumference = self.patient_ambulatory_care.cephalic_perimeter

    eval_resume = fields.Function(fields.Text('Evaluation resume'),
                                 'get_eval_resume')
    
    def get_eval_resume(self, name):
        pool = Pool()
        
        if self.diagnosis:
            diagnosis = "Diag: " + self.diagnosis.name or ''        
        chief_complaint = "Mot Cons: " + self.chief_complaint + "\n" or ''
        present_illness = self.present_illness + "\n" or ''
        evaluation_summary = self.evaluation_summary + "\n" or ''
        directions = "Trat: " + self.directions or ''
        
        eval_resume = chief_complaint + present_illness + evaluation_summary 
        
        if self.diagnosis:
            eval_resume= eval_resume  + diagnosis
        if self.directions:
            eval_resume= eval_resume  + "\n" + directions
        
        return eval_resume
        
    prof_resume = fields.Function(fields.Text('Professional resume'),
                                 'get_prof_resume')
    
    def get_prof_resume(self, name):
        prof = self.healthprof.rec_name + "\n" or ''
        specialty= (self.healthprof.main_specialty and self.healthprof.main_specialty.specialty.name + "\n") or ''
        institution= self.institution.rec_name or ''        
        prof_resume = prof + specialty + institution        
        return prof_resume

    signs_resume = fields.Function(fields.Text('Vital Signs'),
                                 'get_signs_resume')
    
    def get_signs_resume(self, name):
        pool = Pool()    
        
        ta = ""
        
        if self. systolic and self.diastolic:
            systolic = str(self.systolic)
            diastolic= str(self.diastolic)
            ta = systolic + " / " + diastolic + " [mmHg]"
        else:
            ta = " Sin Dato "
       
        if self.bpm:
            bpm= str(self.bpm)
        else:
            bpm = "-"
        
        if self.temperature:
            temperature = str(self.temperature) + " [°C]"
        else:
            temperature = 'Sin Dato'
        
        respiratory_rate = str(self.respiratory_rate) or ''
        osat = str(self.osat) or ''
        glycemia = str(self.glycemia) or ''
        
        
        aux = ""
        if self.cardiovascular_risk == 1:
            aux = "Menor a 10% - BAJO"
        if self.cardiovascular_risk == 3:
            aux = "Entre 10% y 20%- MODERADO"
        if self.cardiovascular_risk == 3:
            aux = "Entre 20% y 30% - ALTO"
        if self.cardiovascular_risk == 4:
            aux = "Entre 30% y 40% - MUY ALTO"
        else:
            aux = "Mayor a 40% - MUY ALTO"
        
        signs_resume = "TA: " + ta + "\n" + "Temp: " + temperature
        
        if self.respiratory_rate or self.bpm:
             signs_resume = signs_resume + "\n" + "LPM: " + bpm + "  " + "FR: " + respiratory_rate
        
        if self.osat:
            signs_resume = signs_resume + "\n" + "SatO2: " + osat
        
        if self.glycemia:
            signs_resume = signs_resume + "\n" + "Gluc: " + glycemia 
        
        if self.cardiovascular_risk:
            signs_resume = signs_resume + "\n" + "RCG: " + aux
        
        return signs_resume
    
    @fields.depends('weight','height','patient_ambulatory_care')
    def on_change_with_bmi(self):
        if self.weight and self.height:
            self.bmi = float(self.weight) / pow((float(self.height)/100),2)
            return self.bmi

    wboys_w = [[2.5,2.8,3.0,3.3,3.7,4.0,4.3],[2.6,2.9,3.2,3.5,3.8,4.2,4.5],
           [2.8,3.1,3.4,3.8,4.1,4.5,4.9],[3.1,3.4,3.7,4.1,4.5,4.8,5.2],
           [3.4,3.7,4.0,4.4,4.8,5.2,5.6],[3.6,3.9,4.3,4.7,5.1,5.5,5.9],
           [3.8,4.2,4.5,4.9,5.4,5.8,6.3],[4.1,4.4,4.8,5.2,5.6,6.1,6.5],
           [4.3,4.6,5.0,5.4,5.9,6.3,6.8],[4.4,4.8,5.2,5.6,6.1,6.6,7.1],
           [4.6,5.0,5.4,5.8,6.3,6.8,7.3],[4.8,5.2,5.6,6.0,6.5,7.0,7.5],
           [4.9,5.3,5.7,6.2,6.7,7.2,7.7]]

    wgirls_w = [[2.4,2.7,2.9,3.2,3.6,3.9,4.2],[2.5,2.8,3.0,3.3,3.7,4.0,4.4],
            [2.7,3.0,3.2,3.6,3.9,4.3,4.6],[2.9,3.2,3.5,3.8,4.2,4.6,5.0],
            [3.1,3.4,3.7,4.1,4.5,4.9,5.3],[3.3,3.6,4.0,4.3,4.8,5.2,5.6],
            [3.5,3.8,4.2,4.6,5.0,5.4,5.9],[3.7,4.0,4.4,4.8,5.2,5.7,6.1],
            [3.9,4.2,4.6,5.0,5.5,5.9,6.4],[4.1,4.4,4.7,5.2,5.7,6.1,6.6],
            [4.2,4.5,4.9,5.4,5.8,6.3,6.8],[4.3,4.7,5.1,5.5,6.0,6.5,7.0],
            [4.5,4.8,5.2,5.7,6.2,6.7,7.2]]

    wboys_m = [[2.5,2.8,3.0,3.3,3.7,4.0,4.3],[3.4,3.8,4.1,4.5,4.9,5.3,5.7],
           [4.4,4.7,5.1,5.6,6.0,6.5,7.0],[5.1,5.5,5.9,6.4,6.9,7.4,7.9],
           [5.6,6.0,6.5,7.0,7.6,8.1,8.6],[6.1,6.5,7.0,7.5,8.1,8.6,9.2],
           [6.4,6.9,7.4,7.9,8.5,9.1,9.7],[6.7,7.2,7.7,8.3,8.9,9.5,10.2],
           [7.0,7.5,8.0,8.6,9.3,9.9,10.5],[7.2,7.7,8.3,8.9,9.6,10.2,10.9],
           [7.5,8.0,8.5,9.2,9.9,10.5,11.2],[7.7,8.2,8.7,9.4,10.1,10.8,11.5],
           [7.8,8.4,9.0,9.6,10.4,11.1,11.8],[8.0,8.6,9.2,9.9,10.6,11.4,12.1],
           [8.2,8.8,9.4,10.1,10.9,11.6,12.4],[8.4,9.0,9.6,10.3,11.1,11.9,12.7],
           [8.5,9.1,9.8,10.5,11.3,12.1,12.9],[8.7,9.3,10.0,10.7,11.6,12.4,13.2],
           [8.9,9.5,10.1,10.9,11.8,12.6,13.5],[9.0,9.7,10.3,11.1,12.0,12.9,13.7],
           [9.2,9.8,10.5,11.3,12.2,13.1,14.0],[9.3,10.0,10.7,11.5,12.5,13.3,14.3],
           [9.5,10.2,10.9,11.8,12.7,13.6,14.5],[9.7,10.3,11.1,12.0,12.9,13.8,14.8],
           [9.8,10.5,11.3,12.2,13.1,14.1,15.1],[10.0,10.7,11.4,12.4,13.3,14.3,15.3],
           [10.1,10.8,11.6,12.5,13.6,14.6,15.6],[10.2,11.0,11.8,12.7,13.8,14.8,15.9],
           [10.4,11.1,12.0,12.9,14.0,15.0,16.1],[10.5,11.3,12.1,13.1,14.2,15.2,16.4],
           [10.7,11.4,12.3,13.3,14.4,15.5,16.6],[10.8,11.6,12.4,13.5,14.6,15.7,16.9],
           [10.9,11.7,12.6,13.7,14.8,15.9,17.1],[11.1,11.9,12.8,13.8,15.0,16.1,17.3],
           [11.2,12.0,12.9,14.0,15.2,16.3,17.6],[11.3,12.2,13.1,14.2,15.4,16.6,17.8],
           [11.4,12.3,13.2,14.3,15.6,16.8,18.0],[11.6,12.4,13.4,14.5,15.8,17.0,18.3],
           [11.7,12.6,13.5,14.7,15.9,17.2,18.5],[11.8,12.7,13.7,14.8,16.1,17.4,18.7],
           [11.9,12.8,13.8,15.0,16.3,17.6,19.0],[12.1,13.0,14.0,15.2,16.5,17.8,19.2],
           [12.2,13.1,14.1,15.3,16.7,18.0,19.4],[12.3,13.2,14.3,15.5,16.9,18.2,19.7],
           [12.4,13.4,14.4,15.7,17.1,18.4,19.9],[12.5,13.5,14.6,15.8,17.3,18.6,20.1],
           [12.7,13.6,14.7,16.0,17.4,18.9,20.4],[12.8,13.8,14.9,16.2,17.6,19.1,20.6],
           [12.9,13.9,15.0,16.3,17.8,19.3,20.9],[13.0,14.0,15.2,16.5,18.0,19.5,21.1],
           [13.1,14.2,15.3,16.7,18.2,19.7,21.3],[13.3,14.3,15.4,16.8,18.4,19.9,21.6],
           [13.4,14.4,15.6,17.0,18.6,20.1,21.8],[13.5,14.6,15.7,17.2,18.8,20.3,22.1],
           [13.6,14.7,15.9,17.3,19.0,20.6,22.3],[13.7,14.8,16.0,17.5,19.2,20.8,22.5],
           [13.8,14.9,16.2,17.7,19.3,21.0,22.8],[13.9,15.1,16.3,17.8,19.5,21.2,23.0],
           [14.1,15.2,16.5,18.0,19.7,21.4,23.3],[14.2,15.3,16.6,18.2,19.9,21.6,23.5],
           [14.3,15.5,16.7,18.3,20.1,21.9,23.8],
           [14.580,15.711,16.967,18.506,20.216,21.920,23.774],[14.711,15.854,17.123,18.680,20.413,22.142,24.026],
           [14.844,15.998,17.280,18.856,20.612,22.366,24.279],[14.978,16.143,17.439,19.034,20.812,22.591,24.535],
           [15.114,16.290,17.600,19.213,21.015,22.819,24.793],[15.251,16.438,17.762,19.394,21.218,23.048,25.053],
           [15.389,16.588,17.926,19.576,21.424,23.280,25.315],[15.530,16.740,18.091,19.761,21.632,23.513,25.580],
           [15.672,16.893,18.259,19.947,21.841,23.749,25.847],[15.815,17.048,18.427,20.134,22.053,23.986,26.117],
           [15.959,17.204,18.597,20.324,22.265,24.226,26.388],[16.105,17.361,18.768,20.514,22.480,24.467,26.661],
           [16.252,17.519,18.941,20.705,22.695,24.709,26.937],[16.400,17.678,19.114,20.898,22.912,24.953,27.215],
           [16.548,17.839,19.288,21.092,23.131,25.200,27.494],[16.697,17.999,19.464,21.287,23.351,25.448,27.777],
           [16.848,18.161,19.640,21.483,23.572,25.697,28.061],[16.999,18.324,19.818,21.681,23.795,25.949,28.349],
           [17.150,18.488,19.996,21.880,24.020,26.203,28.639],[17.303,18.653,20.176,22.080,24.246,26.459,28.931],
           [17.455,18.818,20.356,22.281,24.474,26.717,29.227],[17.609,18.983,20.537,22.484,24.703,26.977,29.525],
           [17.762,19.150,20.719,22.687,24.934,27.240,29.826],[17.916,19.316,20.901,22.892,25.167,27.504,30.130],
           [18.070,19.483,21.084,23.097,25.400,27.770,30.436],[18.224,19.650,21.268,23.303,25.635,28.038,30.746],
           [18.378,19.818,21.452,23.510,25.872,28.309,31.059],[18.532,19.986,21.636,23.718,26.110,28.581,31.375],
           [18.686,20.154,21.821,23.927,26.350,28.856,31.695],[18.841,20.322,22.007,24.137,26.591,29.134,32.017],
           [18.995,20.490,22.193,24.348,26.834,29.413,32.343],[19.148,20.658,22.379,24.560,27.078,29.695,32.674],
           [19.302,20.827,22.566,24.772,27.324,29.980,33.007],[19.456,20.995,22.754,24.986,27.572,30.267,33.345],
           [19.609,21.164,22.941,25.200,27.821,30.558,33.687],[19.763,21.333,23.130,25.416,28.073,30.850,34.033],
           [19.916,21.502,23.319,25.633,28.326,31.147,34.384],[20.069,21.671,23.508,25.851,28.582,31.446,34.740],
           [20.222,21.840,23.698,26.071,28.839,31.748,35.099],[20.375,22.010,23.889,26.291,29.099,32.053,35.464],
           [20.528,22.180,24.080,26.513,29.360,32.362,35.832],[20.681,22.350,24.272,26.736,29.624,32.673,36.206],
           [20.833,22.521,24.465,26.960,29.890,32.989,36.585],[20.986,22.692,24.659,27.186,30.158,33.307,36.969],
           [21.140,22.863,24.853,27.414,30.429,33.629,37.358],[21.293,23.036,25.049,27.643,30.703,33.956,37.753],
           [21.448,23.209,25.247,27.875,30.980,34.287,38.155],[21.603,23.384,25.446,28.109,31.260,34.622,38.562],
           [21.759,23.560,25.647,28.346,31.544,34.962,38.975],[21.917,23.737,25.850,28.585,31.831,35.307,39.395],
           [22.076,23.917,26.056,28.828,32.122,35.656,39.820],[22.236,24.098,26.263,29.073,32.417,36.010,40.252],
           [22.398,24.282,26.474,29.322,32.716,36.369,40.690],[22.561,24.467,26.687,29.574,33.020,36.734,41.135],
           [22.727,24.655,26.902,29.829,33.327,37.104,41.587],[22.894,24.845,27.121,30.088,33.639,37.479,42.044],
           [23.063,25.037,27.342,30.350,33.956,37.859,42.508],[23.234,25.231,27.566,30.616,34.276,38.245,42.978],
           [23.406,25.428,27.793,30.885,34.601,38.635,43.455],[23.581,25.627,28.023,31.159,34.931,39.032,43.938],]

    wgirls_m = [[2.4,2.7,2.9,3.2,3.6,3.9,4.2],[3.2,3.5,3.8,4.2,4.6,5.0,5.4],
            [4.0,4.3,4.7,5.1,5.6,6.0,6.5],[4.6,5.0,5.4,5.8,6.4,6.9,7.4],
            [5.1,5.5,5.9,6.4,7.0,7.5,8.1],[5.5,5.9,6.4,6.9,7.5,8.1,8.7],
            [5.8,6.2,6.7,7.3,7.9,8.5,9.2],[6.1,6.5,7.0,7.6,8.3,8.9,9.6],
            [6.3,6.8,7.3,7.9,8.6,9.3,10.0],[6.6,7.0,7.6,8.2,8.9,9.6,10.4],
            [6.8,7.3,7.8,8.5,9.2,9.9,10.7],[7.0,7.5,8.0,8.7,9.5,10.2,11.0],
            [7.1,7.7,8.2,8.9,9.7,10.5,11.3],[7.3,7.9,8.4,9.2,10.0,10.8,11.6],
            [7.5,8.0,8.6,9.4,10.2,11.0,11.9],[7.7,8.2,8.8,9.6,10.4,11.3,12.2],
            [7.8,8.4,9.0,9.8,10.7,11.5,12.5],[8.0,8.6,9.2,10.0,10.9,11.8,12.7],
            [8.2,8.8,9.4,10.2,11.1,12.0,13.0],[8.3,8.9,9.6,10.4,11.4,12.3,13.3],
            [8.5,9.1,9.8,10.6,11.6,12.5,13.5],[8.7,9.3,10.0,10.9,11.8,12.8,13.8],
            [8.8,9.5,10.2,11.1,12.0,13.0,14.1],[9.0,9.7,10.4,11.3,12.3,13.3,14.3],
            [9.2,9.8,10.6,11.5,12.5,13.5,14.6],[9.3,10.0,10.8,11.7,12.7,13.8,14.9],
            [9.5,10.2,10.9,11.9,12.9,14.0,15.2],[9.6,10.4,11.1,12.1,13.2,14.3,15.4],
            [9.8,10.5,11.3,12.3,13.4,14.5,15.7],[10.0,10.7,11.5,12.5,13.6,14.7,16.0],
            [10.1,10.9,11.7,12.7,13.8,15.0,16.2],[10.3,11.0,11.9,12.9,14.1,15.2,16.5],
            [10.4,11.2,12.0,13.1,14.3,15.5,16.8],[10.5,11.3,12.2,13.3,14.5,15.7,17.0],
            [10.7,11.5,12.4,13.5,14.7,15.9,17.3],[10.8,11.6,12.5,13.7,14.9,16.2,17.6],
            [11.0,11.8,12.7,13.9,15.1,16.4,17.8],[11.1,11.9,12.9,14.0,15.3,16.7,18.1],
            [11.2,12.1,13.0,14.2,15.6,16.9,18.4],[11.4,12.2,13.2,14.4,15.8,17.1,18.6],
            [11.5,12.4,13.4,14.6,16.0,17.4,18.9],[11.6,12.5,13.5,14.8,16.2,17.6,19.2],
            [11.8,12.7,13.7,15.0,16.4,17.9,19.5],[11.9,12.8,13.9,15.2,16.6,18.1,19.7],
            [12.0,13.0,14.0,15.3,16.8,18.3,20.0],[12.1,13.1,14.2,15.5,17.0,18.6,20.3],
            [12.3,13.2,14.3,15.7,17.3,18.8,20.6],[12.4,13.4,14.5,15.9,17.5,19.1,20.8],
            [12.5,13.5,14.7,16.1,17.7,19.3,21.1],[12.6,13.7,14.8,16.3,17.9,19.5,21.4],
            [12.8,13.8,15.0,16.4,18.1,19.8,21.7],[12.9,13.9,15.1,16.6,18.3,20.0,22.0],
            [13.0,14.1,15.3,16.8,18.5,20.3,22.2],[13.1,14.2,15.4,17.0,18.7,20.5,22.5],
            [13.2,14.3,15.6,17.2,18.9,20.8,22.8],[13.4,14.5,15.8,17.3,19.1,21.0,23.1],
            [13.5,14.6,15.9,17.5,19.3,21.2,23.3],[13.6,14.8,16.1,17.7,19.6,21.5,23.6],
            [13.7,14.9,16.2,17.9,19.8,21.7,23.9],[13.8,15.0,16.4,18.0,20.0,21.9,24.4],
            [14.0,15.2,16.5,18.2,20.2,22.2,24.4],
            [14.580,15.711,16.967,18.506,20.216,21.920,23.774],[14.711,15.854,17.123,18.680,20.413,22.142,24.026],
            [14.844,15.998,17.280,18.856,20.612,22.366,24.279],[14.978,16.143,17.439,19.034,20.812,22.591,24.535],
            [15.114,16.290,17.600,19.213,21.015,22.819,24.793],[15.251,16.438,17.762,19.394,21.218,23.048,25.053],
            [15.389,16.588,17.926,19.576,21.424,23.280,25.315],[15.530,16.740,18.091,19.761,21.632,23.513,25.580],
            [15.672,16.893,18.259,19.947,21.841,23.749,25.847],[15.815,17.048,18.427,20.134,22.053,23.986,26.117],
            [15.959,17.204,18.597,20.324,22.265,24.226,26.388],[16.105,17.361,18.768,20.514,22.480,24.467,26.661],
            [16.252,17.519,18.941,20.705,22.695,24.709,26.937],[16.400,17.678,19.114,20.898,22.912,24.953,27.215],
            [16.548,17.839,19.288,21.092,23.131,25.200,27.494],[16.697,17.999,19.464,21.287,23.351,25.448,27.777],
            [16.848,18.161,19.640,21.483,23.572,25.697,28.061],[16.999,18.324,19.818,21.681,23.795,25.949,28.349],
            [17.150,18.488,19.996,21.880,24.020,26.203,28.639],[17.303,18.653,20.176,22.080,24.246,26.459,28.931],
            [17.455,18.818,20.356,22.281,24.474,26.717,29.227],[17.609,18.983,20.537,22.484,24.703,26.977,29.525],
            [17.762,19.150,20.719,22.687,24.934,27.240,29.826],[17.916,19.316,20.901,22.892,25.167,27.504,30.130],
            [18.070,19.483,21.084,23.097,25.400,27.770,30.436],[18.224,19.650,21.268,23.303,25.635,28.038,30.746],
            [18.378,19.818,21.452,23.510,25.872,28.309,31.059],[18.532,19.986,21.636,23.718,26.110,28.581,31.375],
            [18.686,20.154,21.821,23.927,26.350,28.856,31.695],[18.841,20.322,22.007,24.137,26.591,29.134,32.017],
            [18.995,20.490,22.193,24.348,26.834,29.413,32.343],[19.148,20.658,22.379,24.560,27.078,29.695,32.674],
            [19.302,20.827,22.566,24.772,27.324,29.980,33.007],[19.456,20.995,22.754,24.986,27.572,30.267,33.345],
            [19.609,21.164,22.941,25.200,27.821,30.558,33.687],[19.763,21.333,23.130,25.416,28.073,30.850,34.033],
            [19.916,21.502,23.319,25.633,28.326,31.147,34.384],[20.069,21.671,23.508,25.851,28.582,31.446,34.740],
            [20.222,21.840,23.698,26.071,28.839,31.748,35.099],[20.375,22.010,23.889,26.291,29.099,32.053,35.464],
            [20.528,22.180,24.080,26.513,29.360,32.362,35.832],[20.681,22.350,24.272,26.736,29.624,32.673,36.206],
            [20.833,22.521,24.465,26.960,29.890,32.989,36.585],[20.986,22.692,24.659,27.186,30.158,33.307,36.969],
            [21.140,22.863,24.853,27.414,30.429,33.629,37.358],[21.293,23.036,25.049,27.643,30.703,33.956,37.753],
            [21.448,23.209,25.247,27.875,30.980,34.287,38.155],[21.603,23.384,25.446,28.109,31.260,34.622,38.562],
            [21.759,23.560,25.647,28.346,31.544,34.962,38.975],[21.917,23.737,25.850,28.585,31.831,35.307,39.395],
            [22.076,23.917,26.056,28.828,32.122,35.656,39.820],[22.236,24.098,26.263,29.073,32.417,36.010,40.252],
            [22.398,24.282,26.474,29.322,32.716,36.369,40.690],[22.561,24.467,26.687,29.574,33.020,36.734,41.135],
            [22.727,24.655,26.902,29.829,33.327,37.104,41.587],[22.894,24.845,27.121,30.088,33.639,37.479,42.044],
            [23.063,25.037,27.342,30.350,33.956,37.859,42.508],[23.234,25.231,27.566,30.616,34.276,38.245,42.978],
            [23.406,25.428,27.793,30.885,34.601,38.635,43.455],[23.581,25.627,28.023,31.159,34.931,39.032,43.938],]

    
    hgirls_w = [[45.6,46.7,47.8,49.1,50.4,51.5,52.7],
            [46.8,47.9,49.0,50.3,51.6,52.7,53.9],
            [47.9,49.0,50.2,51.5,52.7,53.9,55.1],
            [48.8,50.0,51.1,52.5,53.7,54.9,56.1],
            [49.7,50.8,52.0,53.4,54.6,55.8,57.0],
            [50.5,51.7,52.9,54.2,55.5,56.7,57.9],
            [51.3,52.5,53.7,55.1,56.4,57.6,58.8],
            [52.1,53.2,54.4,55.8,57.1,58.4,59.6],
            [52.8,54.0,55.3,56.6,58.0,59.2,60.7],
            [53.4,54.7,55.9,57.3,58.7,59.9,61.1],
            [54.1,55.3,56.5,57.9,59.3,60.5,61.8],
            [54.7,55.9,57.1,58.6,59.9,61.2,62.5],
            [55.3,56.5,57.8,59.2,60.6,61.9,63.1]]

    hboys_w = [[46.3,47.4,48.6,49.9,51.1,52.3,53.4],
           [47.5,48.6,49.8,51.1,52.3,53.5,54.7],
           [48.8,49.8,51.0,52.3,53.6,54.7,55.9],
           [49.8,50.9,52.0,53.4,54.6,55.8,57.0],
           [50.7,51.9,53.0,54.4,55.6,56.8,58.0],
           [51.7,52.8,54.0,55.3,56.6,57.8,59.0],
           [52.5,53.7,54.9,56.2,57.5,58.7,59.9],
           [53.4,54.5,55.7,57.1,58.4,59.6,60.8],
           [54.1,55.3,56.5,57.9,59.2,60.4,61.6],
           [54.9,56.0,57.3,58.7,60.0,61.2,62.4],
           [55.6,59.8,58.0,59.4,60.7,61.9,63.2],
           [56.3,57.4,58.7,60.1,61.4,62.6,63.9],
           [56.9,58.1,59.3,60.8,62.1,63.3,64.6]]

    hboys_m = [[46.3,47.4,48.6,49.9,51.1,52.3,53.4],[51.1,52.3,53.4,54.7,56.1,57.2,58.4],
            [54.7,55.9,57.1,58.4,59.8,61.1,62.2],[57.6,58.8,60.1,61.4,62.8,64.1,65.3],
            [60.0,61.2,62.5,63.9,65.3,66.5,67.8],[61.9,63.2,64.5,65.9,67.3,68.6,69.9],
            [63.6,64.9,66.2,67.6,69.1,70.4,71.6],[65.1,66.4,67.7,69.2,70.6,71.9,73.2],
            [66.5,67.8,69.1,70.6,72.1,73.4,74.7],[67.7,69.1,70.5,72.0,73.5,74.8,76.2],
            [69.0,70.4,71.8,73.3,74.8,76.2,77.6],[70.2,71.5,73.0,74.5,76.1,77.5,78.9],
            [71.3,72.7,74.1,75.7,77.3,78.8,80.2],[72.4,73.8,75.3,76.9,78.6,80.0,81.5],
            [73.4,74.9,76.4,78.0,79.7,81.2,82.7],[74.4,75.9,77.4,79.1,80.8,82.4,83.9],
            [75.4,76.9,78.5,80.2,82.0,83.5,85.1],[76.3,77.9,79.5,81.2,83.0,84.6,86.2],
            [77.2,78.8,80.5,82.3,84.1,85.7,87.3],[78.1,79.7,81.4,83.2,85.1,86.8,88.4],
            [78.9,80.6,82.3,84.2,86.1,87.8,89.5],[79.7,81.5,83.2,85.1,87.1,88.8,90.5],
            [80.5,82.3,84.1,86.0,88.0,89.8,91.6],[81.3,83.1,84.9,86.9,89.0,90.8,92.6],
            [81.4,83.2,85.0,87.1,89.2,91.0,92.9],[82.1,84.0,85.9,88.0,90.1,92.0,93.8],
            [82.8,84.7,86.7,88.8,90.9,92.9,94.8],[83.5,85.5,87.4,89.6,91.8,93.8,95.7],
            [84.2,86.2,88.2,90.4,92.7,94.7,96.6],[84.9,86.9,89.0,91.2,93.5,95.5,97.5],
            [85.5,87.6,89.7,91.9,94.3,96.3,98.3],[86.2,88.2,90.3,92.7,95.0,97.1,99.2],
            [86.8,88.9,91.0,93.4,95.7,97.9,100.0],[87.4,89.5,91.7,94.1,96.5,98.7,100.8],
            [88.0,90.2,92.4,94.8,97.2,99.4,101.5],[88.5,90.7,93.0,95.4,97.9,100.1,102.3],
            [89.1,91.3,93.6,96.1,98.6,100.8,103.1],[89.7,91.9,94.2,96.7,99.3,101.5,103.8],
            [90.2,92.5,94.8,97.4,99.9,102.2,104.5],[90.8,93.1,95.4,98.0,100.6,102.9,105.2],
            [91.3,93.7,96.0,98.6,101.3,103.6,105.9],[91.9,94.2,96.6,99.2,101.9,104.3,106.6],
            [92.4,94.8,97.2,99.9,102.5,104.9,107.3],[92.9,95.3,97.7,100.4,103.1,105.6,108.0],
            [93.4,95.9,98.3,101.0,103.8,106.2,108.6],[93.9,96.4,98.9,101.6,104.4,106.8,109.3],
            [94.4,96.9,99.4,102.2,105.0,107.5,109.9],[94.9,97.4,100.2,102.8,105.6,108.1,110.6],
            [95.4,98.0,100.5,103.3,106.2,108.7,111.2],[95.9,98.5,101.8,103.9,106.7,109.3,111.8],
            [96.4,99.0,101.6,104.4,107.3,109.9,112.5],[96.9,99.5,102.1,105.0,107.9,110.5,113.1],
            [97.4,100.0,102.6,105.6,108.5,111.1,113.7],[97.9,100.5,103.1,106.1,109.1,111.7,114.3],
            [98.4,101.0,103.7,106.7,109.6,112.3,115.0],[98.8,101.5,104.2,107.2,110.2,112.9,115.6],
            [99.3,102.0,104.7,107.8,110.8,113.5,116.2],[99.8,102.5,105.3,108.3,111.4,114.1,116.8],
            [100.3,103.0,105.8,108.9,111.9,114.7,117.4],[100.8,103.5,106.3,109.4,112.5,115.3,118.1],
            [101.2,104.0,106.8,110.0,113.1,115.9,118.7],
            [101.629,104.381,107.168,110.265,113.362,116.149,118.900],[102.106,104.876,107.683,110.801,113.918,116.725,119.495],
            [102.581,105.370,108.195,111.334,114.473,117.298,120.087],[103.054,105.861,108.704,111.864,115.023,117.866,120.673],
            [103.522,106.347,109.209,112.390,115.570,118.432,121.257],[103.985,106.829,109.710,112.911,116.112,118.993,121.837],
            [104.444,107.307,110.206,113.428,116.650,119.549,122.412],[104.902,107.782,110.699,113.941,117.183,120.100,122.980],
            [105.353,108.252,111.188,114.450,117.712,120.648,123.547],[105.801,108.717,111.672,114.955,118.238,121.192,124.109],
            [106.246,109.180,112.152,115.455,118.758,121.730,124.664],[106.685,109.637,112.628,115.951,119.274,122.265,125.217],
            [107.120,110.091,113.100,116.443,119.787,122.796,125.766],[107.555,110.543,113.569,116.932,120.296,123.322,126.310],
            [107.985,110.991,114.036,117.420,120.803,123.848,126.854],[108.414,111.437,114.501,117.905,121.308,124.372,127.396],
            [108.842,111.884,114.965,118.388,121.811,124.892,127.934],[109.268,112.327,115.426,118.870,122.314,125.413,128.472],
            [109.692,112.769,115.887,119.351,122.815,125.932,129.010],[110.114,113.210,116.346,119.830,123.315,126.451,129.546],
            [110.538,113.651,116.805,120.308,123.812,126.966,130.079],[110.958,114.089,117.261,120.785,124.310,127.482,130.613],
            [111.376,114.525,117.716,121.260,124.805,127.995,131.145],[111.793,114.960,118.169,121.734,125.299,128.508,131.675],
            [112.207,115.393,118.620,122.205,125.791,129.018,132.203],[112.620,115.824,119.069,122.675,126.281,129.526,132.730],
            [113.031,116.253,119.517,123.143,126.769,130.033,133.255],[113.440,116.680,119.962,123.609,127.256,130.538,133.778],
            [113.848,117.106,120.406,124.074,127.741,131.041,134.299],[114.254,117.530,120.849,124.536,128.224,131.543,134.819],
            [114.657,117.951,121.288,124.996,128.704,132.042,135.336],[115.058,118.371,121.726,125.454,129.183,132.538,135.851],
            [115.458,118.788,122.162,125.910,129.659,133.033,136.363],[115.854,119.203,122.595,126.364,130.133,133.525,136.874],
            [116.249,119.616,123.026,126.816,130.605,134.015,137.382],[116.642,120.027,123.456,127.265,131.075,134.503,137.888],
            [117.034,120.436,123.883,127.713,131.543,134.990,138.392],[117.423,120.844,124.309,128.159,132.009,135.474,138.895],
            [117.811,121.249,124.733,128.603,132.474,135.957,139.396],[118.197,121.654,125.156,129.047,132.937,136.439,139.896],
            [118.583,122.058,125.578,129.489,133.400,136.920,140.394],[118.965,122.459,125.998,129.930,133.862,137.401,140.895],
            [119.349,122.860,126.418,130.370,134.323,137.881,141.392],[119.732,123.261,126.837,130.810,134.783,138.359,141.889],
            [120.114,123.662,127.256,131.250,135.243,138.837,142.385],[120.496,124.062,127.675,131.688,135.702,139.315,142.881],
            [120.877,124.461,128.093,132.127,136.161,139.792,143.377],[121.258,124.861,128.510,132.565,136.620,140.270,143.872],
            [121.639,125.260,128.928,133.003,137.079,140.747,144.367],[122.019,125.658,129.344,133.440,137.536,141.223,144.862],
            [122.398,126.055,129.760,133.877,137.994,141.699,145.356],[122.779,126.454,130.177,134.313,138.449,142.172,145.847],
            [123.156,126.850,130.591,134.748,138.905,142.647,146.340],[123.533,127.245,131.005,135.183,139.361,143.121,146.833],
            [123.912,127.641,131.419,135.617,139.814,143.592,147.322],[124.287,128.035,131.832,136.050,140.269,144.065,147.813],
            [124.665,128.430,132.245,136.483,140.721,144.536,148.301],[125.039,128.823,132.656,136.915,141.174,145.008,148.792],
            [125.416,129.217,133.068,137.347,141.626,145.478,149.279],[125.792,129.611,133.481,137.780,142.078,145.948,149.767],
            [126.169,130.006,133.893,138.212,142.531,146.418,150.255],[126.546,130.401,134.306,138.645,142.984,146.890,150.745],
            [126.924,130.797,134.720,139.080,143.439,147.362,151.235],[127.304,131.195,135.136,139.516,143.895,147.837,151.728],
            [127.685,131.594,135.554,139.954,144.354,148.314,152.223],[128.071,131.998,135.975,140.395,144.814,148.792,152.718],
            [128.458,132.403,136.399,140.839,145.279,149.275,153.220],[128.850,132.812,136.826,141.286,145.746,149.760,153.722],
            [129.245,133.225,137.257,141.737,146.217,150.249,154.229],[129.644,133.642,137.692,142.192,146.692,150.742,154.740],
            [130.046,134.062,138.130,142.650,147.170,151.239,155.255],[130.454,134.487,138.573,143.113,147.652,151.738,155.771],
            [130.863,134.915,139.019,143.580,148.140,152.244,156.296],[131.279,135.349,139.471,144.051,148.631,152.754,156.823],
            [131.700,135.787,139.927,144.528,149.128,153.268,157.355],[132.128,136.232,140.390,145.009,149.629,153.786,157.890],
            [132.558,136.681,140.857,145.496,150.136,154.312,158.435],[132.996,137.136,141.330,145.989,150.649,154.842,158.982],
            [133.439,137.597,141.808,146.488,151.167,155.379,159.536],[133.888,138.064,142.293,146.993,151.692,155.922,160.097],
            [134.343,138.536,142.784,147.504,152.224,156.472,160.665],[134.807,139.017,143.283,148.022,152.762,157.027,161.238],
            [135.277,139.505,143.789,148.548,153.307,157.590,161.819],[135.754,140.000,144.301,149.081,153.860,158.162,162.408],
            [136.240,140.504,144.823,149.621,154.420,158.739,163.002],[136.731,141.013,145.350,150.169,154.989,159.326,163.608],
            [137.235,141.533,145.887,150.726,155.564,159.918,164.217],[137.743,142.059,146.432,151.290,156.148,160.521,164.837],
            [138.261,142.595,146.985,151.862,156.740,161.130,165.464],[138.786,143.137,147.545,152.442,157.340,161.748,166.099],
            [139.321,143.689,148.114,153.030,157.946,162.371,166.739],[139.859,144.244,148.687,153.623,158.560,163.003,167.388],
            [140.407,144.809,149.268,154.222,159.177,163.636,168.038],[140.956,145.375,149.852,154.826,159.800,164.276,168.695],
            [141.512,145.947,150.441,155.433,160.425,164.919,169.354],[142.073,146.524,151.033,156.043,161.052,165.561,170.012],
            [142.635,147.102,151.627,156.654,161.681,166.206,170.673],[143.198,147.681,152.221,157.266,162.311,166.851,171.334],
            [143.761,148.259,152.815,157.878,162.940,167.496,171.994],[144.325,148.837,153.408,158.487,163.566,168.137,172.649],
            [144.890,149.415,154.000,159.094,164.188,168.772,173.298],[145.447,149.987,154.586,159.696,164.806,169.405,173.945],
            [146.004,150.557,155.169,160.294,165.419,170.031,174.584],[146.558,151.123,155.748,160.886,166.024,170.649,175.214],
            [147.107,151.684,156.320,161.472,166.624,171.260,175.837],[147.649,152.238,156.886,162.050,167.215,171.863,176.452],
            [148.184,152.784,157.444,162.621,167.798,172.458,177.057],[148.714,153.323,157.993,163.182,168.370,173.040,177.649],
            [149.237,153.855,158.534,163.732,168.930,173.609,178.227],[149.747,154.375,159.063,164.272,169.480,174.168,178.796],
            [150.250,154.886,159.582,164.799,170.017,174.713,179.349],[150.742,155.385,160.088,165.314,170.541,175.244,179.887],
            [151.224,155.874,160.583,165.816,171.050,175.759,180.409],[151.695,156.350,161.065,166.305,171.545,176.260,180.915],
            [152.153,156.813,161.534,166.780,172.025,176.746,181.407],[152.599,157.265,161.991,167.242,172.492,177.218,181.884],
            [153.037,157.705,162.435,167.690,172.945,177.674,182.343],[153.463,158.135,162.867,168.126,173.384,178.116,182.788],
            [153.877,158.552,163.287,168.548,173.809,178.545,183.219],[154.280,158.957,163.694,168.958,174.222,178.959,183.636],
            [154.674,159.352,164.090,169.355,174.620,179.358,184.036],[155.057,159.735,164.474,169.739,175.004,179.743,184.421],
            [155.428,160.106,164.845,170.110,175.375,180.114,184.792],[155.787,160.465,165.203,170.468,175.733,180.471,185.149],
            [156.135,160.812,165.550,170.814,176.078,180.815,185.492],[156.472,161.147,165.884,171.147,176.410,181.146,185.822],
            [156.801,161.474,166.208,171.468,176.728,181.462,186.135],[157.116,161.787,166.519,171.777,177.035,181.767,186.439],
            [157.424,162.092,166.821,172.075,177.329,182.058,186.726],[157.721,162.385,167.111,172.361,177.611,182.336,187.000],
            [158.004,162.665,167.388,172.634,177.881,182.604,187.265],[158.280,162.937,167.655,172.897,178.139,182.857,187.514],
            [158.545,163.197,167.910,173.147,178.384,183.097,187.749],[158.799,163.446,168.155,173.386,178.617,183.325,187.972],
            [159.043,163.685,168.388,173.613,178.838,183.540,188.182],[159.276,163.913,168.609,173.828,179.047,183.743,188.380],
            [159.499,164.130,168.820,174.032,179.244,183.935,188.565],[159.712,164.336,169.020,174.225,179.430,184.114,188.738],
            [159.915,164.532,169.210,174.407,179.604,184.282,188.899],[160.108,164.719,169.389,174.578,179.768,184.438,189.049],
            [160.292,164.895,169.558,174.739,179.920,184.583,189.187],[160.466,165.061,169.717,174.890,180.062,184.718,189.313],
            [160.628,165.217,169.865,175.030,180.195,184.844,189.432],[160.784,165.365,170.005,175.161,180.317,184.957,189.538],
            [160.932,165.504,170.136,175.282,180.429,185.061,189.633],[161.068,165.633,170.257,175.395,180.533,185.157,189.722],
            [161.201,165.756,170.372,175.500,180.627,185.243,189.798],[161.322,165.870,170.477,175.596,180.715,185.322,189.870],
            [161.440,165.979,170.577,175.685,180.793,185.391,189.930],[161.549,166.079,170.668,175.767,180.866,185.455,189.986],
            [161.652,166.173,170.754,175.843,180.933,185.513,190.035],[161.749,166.262,170.834,175.913,180.993,185.564,190.077],
            [161.842,166.346,170.909,175.978,181.048,185.610,190.114],[161.930,166.425,170.979,176.038,181.097,185.651,190.146],
            [162.014,166.500,171.044,176.094,181.143,185.687,190.173],[162.095,166.571,171.106,176.145,181.184,185.718,190.195],
            [162.168,166.637,171.163,176.192,181.222,185.748,190.217],[162.242,166.701,171.218,176.237,181.255,185.772,190.231],
            [162.310,166.760,171.269,176.278,181.287,185.795,190.246],[162.375,166.817,171.317,176.316,181.316,185.815,190.257],
            [162.438,166.871,171.362,176.352,181.342,185.833,190.266],[162.502,166.925,171.406,176.385,181.364,185.845,190.269],
            [162.557,166.973,171.446,176.416,181.386,185.860,190.276],[162.613,167.020,171.485,176.445,181.406,185.870,190.277],
            [162.668,167.066,171.522,176.472,181.423,185.878,190.276],[162.721,167.111,171.557,176.498,181.438,185.885,190.274],
            [162.770,167.151,171.590,176.521,181.453,185.891,190.273],[162.817,167.190,171.621,176.543,181.466,185.896,190.270],]

    hgirls_m = [[45.6,46.7,47.8,49.1,50.4,51.5,52.7],[50.0,51.2,52.4,53.7,55.0,56.2,57.4],
            [53.2,54.4,55.7,57.1,58.4,59.6,60.9],[55.8,57.1,58.4,59.8,61.2,62.5,63.8],
            [58.0,59.3,60.6,62.1,63.5,64.8,66.2],[59.9,61.2,62.5,64.0,65.5,66.9,68.2],
            [61.5,62.8,64.2,65.7,67.3,68.7,70.0],[62.9,64.3,65.7,67.3,68.8,70.3,71.6],
            [64.3,65.7,67.2,68.7,70.4,71.8,73.2],[65.6,67.0,68.5,70.1,71.8,73.2,74.7],
            [66.8,68.3,69.8,71.5,73.1,74.6,76.1],[68.0,69.5,71.1,72.8,74.5,76.0,77.5],
            [69.2,70.7,72.3,74.0,75.7,77.3,78.9],[70.3,71.8,73.4,75.2,77.0,78.6,80.2],
            [71.3,73.0,74.6,76.4,78.2,79.8,81.4],[72.4,74.0,75.7,77.5,79.4,81.0,82.7],
            [73.3,75.0,76.7,78.6,80.5,82.2,83.9],[74.3,76.0,77.7,79.7,81.6,83.3,85.0],
            [75.2,76.9,78.7,80.7,82.6,84.4,86.2],[76.2,77.9,79.7,81.7,83.7,85.5,87.3],
            [77.0,78.8,80.7,82.7,84.7,86.6,88.4],[77.9,79.7,81.6,83.7,85.7,87.6,89.4],
            [78.7,80.6,82.5,84.6,86.7,88.6,90.5],[79.6,81.4,83.4,85.5,87.6,89.6,91.5],
            [79.6,81.6,83.5,85.7,87.9,89.8,91.8],[80.4,82.4,84.4,86.6,88.8,90.8,92.8],
            [81.2,83.2,85.2,87.4,89.7,91.7,93.7],[81.9,83.9,86.0,88.3,90.5,92.6,94.6],
            [82.6,84.7,86.8,89.1,91.4,93.5,95.6],[83.4,85.4,87.5,89.9,92.2,94.3,96.4],
            [84.0,86.2,88.3,90.7,93.1,95.2,97.3],[84.7,86.9,89.0,91.4,93.9,96.0,98.2],
            [85.4,87.5,89.7,92.2,94.6,96.8,99.0],[86.0,88.2,90.5,92.9,95.4,97.6,99.8],
            [86.7,88.9,91.2,93.6,96.2,98.4,100.6],[87.3,89.6,91.8,94.4,96.9,99.2,101.4],
            [87.9,90.2,92.5,95.1,97.7,100.0,102.2],[88.5,90.8,93.1,95.7,98.3,100.7,103.0],
            [89.1,91.4,93.8,96.4,99.0,101.4,103.7],[89.7,92.0,94.4,97.1,99.7,102.1,104.5],
            [90.3,92.6,95.1,97.7,100.4,102.9,105.2],[90.8,93.3,95.7,98.4,101.1,103.6,106.0],
            [91.4,93.8,96.3,99.0,101.8,104.3,106.7],[92.0,94.4,96.9,99.7,102.5,104.9,107,4],
            [92.5,95.0,97.5,100.3,103.1,105.7,108.1],[93.0,95.5,98.1,100.9,103.7,106.3,108.8],
            [93.6,96.1,98.7,101.5,104.4,107.0,109.5],[94.1,96.7,99.3,102.1,105.0,107.6,110.2],
            [94.6,97.2,99.8,102.7,105.6,108.3,110.8],[95.1,97.7,100.4,103.3,106.2,108.9,111.5],
            [95.7,98.3,101.0,103.9,106.9,109.5,112.1],[96.2,98.9,101.5,104.5,107.5,110.2,112.8],
            [96.7,99.3,102.0,105.0,108.1,110.8,113.4],[97.2,99.9,102.6,105.6,108.7,111.4,114.1],
            [97.6,100.4,103.1,106.2,109.2,112.0,114.7],[98.1,100.9,103.7,106.7,109.8,112.6,115.3],
            [98.6,101.4,104.2,107.3,110.4,113.2,116.0],[99.1,101.9,104.7,107.8,111.0,113.8,116.6],
            [99.6,102.4,105.2,108.4,111.6,114.4,117.8],[100.0,102.9,105.7,108.9,112.1,115.0,117.8],
            [100.5,103.4,106.3,109.4,112.7,115.6,118.4],
            [100.624,103.485,106.382,109.602,112.821,115.719,118.579],[101.087,103.967,106.884,110.126,113.367,116.285,119.165],
            [101.545,104.444,107.382,110.645,113.909,116.846,119.745],[101.998,104.917,107.874,111.160,114.445,117.402,120.321],
            [102.449,105.387,108.363,111.670,114.976,117.952,120.890],[102.894,105.851,108.847,112.175,115.504,118.499,121.456],
            [103.337,106.313,109.327,112.677,116.026,119.040,122.016],[103.776,106.771,109.804,113.174,116.544,119.577,122.572],
            [104.212,107.224,110.276,113.667,117.058,120.110,123.123],[104.643,107.674,110.745,114.156,117.568,120.639,123.670],
            [105.071,108.120,111.210,114.642,118.075,121.164,124.213],[105.496,108.563,111.671,115.124,118.578,121.685,124.753],
            [105.920,109.005,112.131,115.604,119.077,122.203,125.288],[106.342,109.445,112.588,116.081,119.574,122.718,125.821],
            [106.760,109.881,113.043,116.557,120.070,123.232,126.354],[107.181,110.319,113.499,117.031,120.563,123.743,126.881],
            [107.599,110.755,113.952,117.504,121.057,124.254,127.410],[108.016,111.190,114.405,117.977,121.549,124.764,127.938],
            [108.435,111.626,114.858,118.449,122.040,125.272,128.463],[108.851,112.060,115.310,118.921,122.532,125.782,128.990],
            [109.270,112.495,115.762,119.393,123.023,126.290,129.515],[109.688,112.931,116.215,119.865,123.514,126.799,130.041],
            [110.107,113.367,116.669,120.337,124.006,127.308,130.568],[110.529,113.805,117.123,120.810,124.498,127.816,131.092],
            [110.949,114.242,117.578,121.284,124.991,128.327,131.620],[111.371,114.681,118.034,121.759,125.484,128.837,132.146],
            [111.792,115.119,118.489,122.234,125.978,129.349,132.676],[112.216,115.559,118.946,122.710,126.473,129.860,133.204],
            [112.643,116.002,119.405,123.187,126.968,130.371,133.731],[113.068,116.444,119.864,123.665,127.465,130.885,134.261],
            [113.494,116.887,120.324,124.144,127.963,131.400,134.793],[113.923,117.333,120.786,124.623,128.461,131.914,135.323],
            [114.354,117.779,121.249,125.104,128.960,132.430,135.855],[114.785,118.227,121.713,125.587,129.461,132.947,136.388],
            [115.218,118.676,122.179,126.071,129.963,133.465,136.923],[115.652,119.126,122.645,126.556,130.466,133.986,137.460],
            [116.087,119.577,123.114,127.042,130.971,134.507,137.998],[116.526,120.032,123.584,127.530,131.477,135.029,138.535],
            [116.966,120.488,124.056,128.020,131.984,135.552,139.074],[117.407,120.945,124.529,128.511,132.493,136.077,139.615],
            [117.850,121.404,125.004,129.004,133.003,136.603,140.157],[118.294,121.863,125.480,129.498,133.515,137.132,140.701],
            [118.742,122.327,125.958,129.993,134.028,137.660,141.245],[119.191,122.791,126.438,130.490,134.543,138.190,141.790],
            [119.639,123.255,126.919,130.989,135.059,138.723,142.339],[120.094,123.725,127.403,131.490,135.576,139.254,142.885],
            [120.547,124.193,127.887,131.991,136.095,139.789,143.435],[121.002,124.663,128.373,132.494,136.616,140.326,143.987],
            [121.460,125.136,128.861,132.999,137.137,140.862,144.538],[121.919,125.610,129.350,133.505,137.659,141.399,145.090],
            [122.380,126.086,129.840,134.012,138.183,141.938,145.644],[122.842,126.562,130.332,134.520,138.708,142.478,146.199],
            [123.307,127.042,130.826,135.030,139.234,143.018,146.753],[123.771,127.521,131.320,135.541,139.762,143.561,147.311],
            [124.239,128.003,131.816,136.053,140.290,144.103,147.868],[124.711,128.488,132.315,136.567,140.819,144.646,148.423],
            [125.181,128.973,132.814,137.082,141.350,145.191,148.983],[125.653,129.459,133.315,137.599,141.883,145.739,149.545],
            [126.128,129.948,133.817,138.117,142.416,146.285,150.105],[126.605,130.439,134.322,138.636,142.951,146.834,150.667],
            [127.087,130.933,134.829,139.158,143.486,147.382,151.228],[127.567,131.426,135.336,139.680,144.024,147.934,151.794],
            [128.051,131.923,135.846,140.205,144.563,148.486,152.359],[128.537,132.422,136.358,140.731,145.104,149.040,152.925],
            [129.025,132.923,136.872,141.259,145.647,149.596,153.494],[129.514,133.425,137.387,141.789,146.191,150.153,154.064],
            [130.008,133.931,137.905,142.321,146.736,150.711,154.634],[130.502,134.437,138.424,142.853,147.283,151.269,155.205],
            [130.998,134.946,138.944,143.387,147.830,151.829,155.777],[131.495,135.454,139.466,143.922,148.379,152.390,156.349],
            [131.992,135.964,139.987,144.458,148.928,152.951,156.923],[132.492,136.475,140.510,144.993,149.476,153.511,157.494],
            [132.992,136.986,141.032,145.528,150.024,154.070,158.064],[133.491,137.497,141.554,146.062,150.570,154.628,158.633],
            [133.992,138.008,142.075,146.595,151.115,155.183,159.198],[134.489,138.515,142.594,147.126,151.658,155.737,159.764],
            [134.986,139.022,143.111,147.655,152.198,156.287,160.324],[135.480,139.527,143.626,148.180,152.735,156.834,160.881],
            [135.971,140.028,144.137,148.702,153.268,157.377,161.433],[136.461,140.526,144.644,149.220,153.795,157.913,161.978],
            [136.944,141.018,145.146,149.732,154.318,158.446,162.520],[137.425,141.507,145.643,150.239,154.835,158.971,163.053],
            [137.899,141.990,146.135,150.739,155.344,159.489,163.580],[138.368,142.467,146.619,151.233,155.846,159.999,164.098],
            [138.832,142.938,147.097,151.718,156.340,160.499,164.605],[139.285,143.399,147.565,152.195,156.825,160.992,165.105],
            [139.733,143.853,148.026,152.663,157.300,161.473,165.592],[140.170,144.296,148.476,153.121,157.765,161.945,166.071],
            [140.599,144.731,148.917,153.568,158.219,162.404,166.536],[141.019,145.156,149.347,154.004,158.661,162.852,166.989],
            [141.428,145.571,149.767,154.429,159.091,163.287,167.430],[141.830,145.976,150.176,154.842,159.509,163.709,167.854],
            [142.218,146.368,150.573,155.244,159.915,164.119,168.269],[142.596,146.749,150.958,155.633,160.308,164.517,168.670],
            [142.965,147.121,151.332,156.010,160.689,164.899,169.056],[143.319,147.479,151.693,156.375,161.057,165.271,169.430],
            [143.666,147.827,152.043,156.727,161.411,165.627,169.788],[144.001,148.164,152.381,157.067,161.752,165.970,170.133],
            [144.324,148.488,152.707,157.394,162.081,166.299,170.463],[144.633,148.799,153.019,157.708,162.397,166.617,170.783],
            [144.934,149.100,153.321,158.010,162.700,166.920,171.086],[145.223,149.390,153.610,158.300,162.989,167.210,171.376],
            [145.502,149.668,153.888,158.577,163.266,167.486,171.652],[145.769,149.935,154.154,158.842,163.531,167.750,171.916],
            [146.023,150.188,154.408,159.096,163.784,168.004,172.169],[146.269,150.433,154.651,159.338,164.025,168.243,172.407],
            [146.505,150.667,154.884,159.569,164.254,168.471,172.633],[146.731,150.891,155.106,159.789,164.472,168.687,172.847],
            [146.947,151.105,155.318,159.998,164.679,168.891,173.049],[147.151,151.308,155.518,160.197,164.876,169.087,173.243],
            [147.348,151.502,155.710,160.386,165.061,169.269,173.423],[147.537,151.687,155.892,160.564,165.236,169.441,173.592],
            [147.713,151.861,156.064,160.733,165.403,169.605,173.754],[147.884,152.028,156.227,160.893,165.558,169.757,173.902],
            [148.043,152.185,156.381,161.043,165.705,169.901,174.043],[148.197,152.335,156.527,161.184,165.842,170.034,174.172],
            [148.341,152.475,156.664,161.318,165.971,170.160,174.294],[148.477,152.608,156.793,161.442,166.092,170.277,174.408],
            [148.606,152.733,156.914,161.560,166.205,170.386,174.513],[148.731,152.853,157.029,161.669,166.309,170.485,174.607],
            [148.847,152.965,157.137,161.772,166.407,170.579,174.697],[148.956,153.070,157.237,161.867,166.498,170.665,174.779],
            [149.056,153.166,157.330,161.956,166.583,170.746,174.856],[149.154,153.259,157.418,162.039,166.660,170.819,174.925],
            [149.246,153.347,157.501,162.116,166.732,170.886,174.987],[149.334,153.429,157.578,162.188,166.798,170.947,175.042],
            [149.413,153.504,157.649,162.254,166.859,171.004,175.096],[149.491,153.577,157.716,162.315,166.915,171.054,175.140],
            [149.561,153.643,157.778,162.372,166.966,171.101,175.183],[149.627,153.704,157.835,162.424,167.013,171.143,175.221],
            [149.693,153.764,157.889,162.472,167.055,171.179,175.251],[149.751,153.818,157.938,162.516,167.093,171.213,175.280],
            [149.807,153.869,157.984,162.556,167.128,171.243,175.305],[149.860,153.917,158.027,162.593,167.160,171.270,175.327],
            [149.910,153.962,158.067,162.628,167.189,171.294,175.346],[149.957,154.004,158.104,162.659,167.215,171.315,175.362],
            [150.000,154.043,158.138,162.689,167.240,171.335,175.378],[150.044,154.081,158.172,162.716,167.261,171.352,175.389],
            [150.083,154.116,158.202,162.742,167.283,171.369,175.402],[150.124,154.152,158.233,162.767,167.301,171.382,175.410],
            [150.161,154.185,158.261,162.790,167.320,171.396,175.420],[150.200,154.218,158.289,162.813,167.336,171.407,175.426],
            [150.235,154.249,158.316,162.834,167.352,171.419,175.433],[150.269,154.279,158.341,162.854,167.368,171.430,175.440],
            [150.302,154.308,158.366,162.874,167.383,171.441,175.446],[150.335,154.337,158.390,162.894,167.397,171.450,175.452],
            [150.368,154.365,158.413,162.912,167.411,171.459,175.456],[150.400,154.392,158.436,162.930,167.424,171.468,175.460],
            [150.431,154.419,158.459,162.948,167.436,171.476,175.464],[150.460,154.444,158.480,162.965,167.450,171.486,175.470],
            [150.490,154.470,158.502,162.982,167.461,171.493,175.473],[150.518,154.494,158.523,162.998,167.474,171.502,175.479],
            [150.548,154.520,158.544,163.014,167.485,171.509,175.481],[150.575,154.543,158.563,163.030,167.497,171.517,175.485],
            [150.601,154.566,158.582,163.045,167.508,171.524,175.489],[150.630,154.590,158.602,163.060,167.517,171.529,175.489],
            [150.655,154.611,158.620,163.073,167.527,171.535,175.492],[150.679,154.632,158.637,163.086,167.536,171.540,175.493],
            [150.702,154.652,158.653,163.098,167.544,171.545,175.494],[150.725,154.671,158.668,163.109,167.551,171.548,175.494],
            [150.743,154.686,158.681,163.119,167.557,171.552,175.495],[150.763,154.703,158.694,163.128,167.562,171.553,175.492],
            [150.783,154.718,158.706,163.136,167.565,171.553,175.488],[150.798,154.731,158.715,163.142,167.569,171.553,175.486],
            [150.815,154.744,158.724,163.147,167.569,171.550,175.479],[150.828,154.754,158.731,163.151,167.570,171.548,175.474],
            [150.842,154.765,158.738,163.153,167.568,171.542,175.465],[150.853,154.772,158.743,163.155,167.567,171.537,175.457],]
    
    
    bmiboys_w = [[11.3,11.9,12.6,13.4,14.8,15.2,16.1],[11.0,11.7,12.5,13.3,14.2,15.1,15.9],
             [11.3,12.0,12.8,13.6,14.5,15.3,16.2],[11.9,12.6,13.4,14.2,15.1,16.0,16.8],
             [12.4,13.1,13.9,14.8,15.7,16.6,17.4],[12.8,13.6,14.3,15.2,16.2,17.1,18.0],
             [13.2,13.9,14.7,15.6,16.6,17.5,18.4],[13.5,14.2,15.0,15.9,16.9,17.8,18.7],
             [13.7,14.4,15.2,16.2,17.1,18.1,19.0],[13.9,14.6,15.4,16.4,17.4,18.3,19.3],
             [14.1,14.8,15.6,16.5,17.5,18.5,19.4],[14.2,14.9,15.7,16.7,17.7,18.6,19.6],
             [14.3,15.4,16.8,18.4,19.7]]

    bmigirls_w = [[11.2,11.8,12.5,13.3,14.2,15.0,15.9],[10.8,11.6,12.3,13.2,14.1,14.9,15.8],
              [11.1,11.8,12.6,13.5,14.3,15.2,16.0],[11.5,12.3,13.1,14.0,14.9,15.7,16.6],
              [12.0,12.7,13.5,14.4,15.4,16.3,17.2],[12.3,13.1,13.9,14.8,15.8,16.7,17.6],
              [12.6,13.4,14.2,15.1,16.1,17.1,18.0],[12.9,13.6,14.4,15.4,16.4,17.4,18.3],
              [13.1,13.8,14.7,15.6,16.6,17.6,18.6],[13.2,14.0,14.9,15.8,16.8,17.8,18.8],
              [13.4,14.2,15.0,16.0,17.0,18.0,19.0],[13.5,14.3,15.1,16.1,17.2,18.2,19.2],
              [13.6,14.4,15.3,16.2,17.3,18.3,19.3]]

    bmiboys_m = [[11.3,11.9,12.6,13.4,14.3,15.2,16.1],[12.6,13.3,14.1,14.9,15.9,16.7,17.6], 
            [13.8,14.6,15.4,16.3,17.3,18.2,19.2],[14.4,15.2,16.0,16.9,17.9,18.8,19.8],
            [14.7,15.4,16.2,17.2,18.2,19.1,20.1],[14.8,15.6,16.4,17.3,18.3,19.2,20.2],
            [14.9,15.6,16.4,17.3,18.3,19.3,20.3],[14.9,15.6,16.4,17.3,18.3,19.3,20.3],
            [14.9,15.6,16.3,17.3,18.2,19.2,20.2],[14.8,15.5,16.3,17.2,18.1,19.1,20.1],
            [14.7,15.4,16.2,17.0,18.0,18.9,19.9],[14.6,15.3,16.0,16.9,17.9,18.8,19.8],
            [14.5,15.2,15.9,16.8,17.7,18.7,19.6],[14.4,15.1,15.8,16.7,17.6,18.5,19.5],
            [14.3,15.0,15.7,16.6,17.5,18.4,19.3],[14.2,14.9,15.6,16.4,17.4,18.2,19.2],
            [14.2,14.8,15.5,16.3,17.2,18.1,19.1],[14.1,14.7,15.4,16.2,17.1,18.0,18.9],
            [14.0,14.6,15.3,16.1,17.1,17.9,18.8],[13.9,14.6,15.2,16.1,16.9,17.8,18.7],
            [13.9,14.5,15.2,16.0,16.9,17.7,18.6],[13.8,14.4,15.1,15.9,16.8,17.6,18.6],
            [13.8,14.4,15.0,15.8,16.7,17.6,18.5],[13.7,14.3,15.0,15.8,16.7,17.5,18.4],
            [13.3,14.3,14.9,15.7,16.6,17.4,18.3],[13.9,14.5,15.2,16.0,16.9,17.7,18.6],
            [13.8,14.5,15.1,15.9,16.8,17.7,18.6],[13.8,14.4,15.1,15.9,16.8,17.6,18.5],
            [13.8,14.4,15.1,15.9,16.7,17.6,18.5],[13.7,14.4,15.0,15.8,16.7,17.5,18.4],
            [13.7,14.3,15.0,15.8,16.7,17.5,18.4],[13.7,14.3,15.0,15.8,16.6,17.5,18.4],
            [13.6,14.2,14.9,15.7,16.6,17.4,18.3],[13.6,14.2,14.9,15.7,16.6,17.4,18.3],
            [13.5,14.2,14.9,15.7,16.5,17.4,18.2],[13.5,14.1,14.8,15.6,16.5,17.3,18.2],
            [13.5,14.1,14.8,15.6,16.5,17.3,18.2],[13.5,14.1,14.8,15.6,16.4,17.3,18.1],
            [13.4,14.1,14.7,15.5,16.4,17.2,18.1],[13.4,14.0,14.7,15.5,16.4,17.2,18.1],
            [13.4,14.0,14.7,15.5,16.4,17.2,18.1],[13.3,14.0,14.7,15.5,16.3,17.2,18.0],
            [13.3,13.9,14.6,15.4,16.3,17.1,18.0],[13.3,13.9,14.6,15.4,16.3,17.1,18.0],
            [13.3,13.9,14.6,15.4,16.3,17.1,18.0],[13.3,13.9,14.6,15.4,16.3,17.1,18.0],
            [13.2,13.9,14.5,15.4,16.2,17.1,18.0],[13.2,13.8,14.5,15.3,16.2,17.1,18.0],
            [13.2,13.8,14.5,15.3,16.2,17.1,18.0],[13.2,13.8,14.5,15.3,16.2,17.1,18.0],
            [13.2,13.8,14.5,15.3,16.2,17.1,18.0],[13.1,13.8,14.5,15.3,16.2,17.1,18.0],
            [13.1,13.8,14.4,15.3,16.2,17.1,18.0],[13.1,13.7,14.4,15.3,16.2,17.1,18.0],
            [13.1,13.7,14.4,15.3,16.2,17.0,18.0],[13.1,13.7,14.4,15.2,16.2,17.0,18.0],
            [13.1,13.7,14.4,15.2,16.1,17.0,18.0],[13.0,13.7,14.4,15.2,16.1,17.1,18.0],
            [13.0,13.7,14.4,15.2,16.1,17.1,18.0],[13.0,13.7,14.4,15.2,16.1,17.1,18.1],
            [13.0,13.6,14.3,15.2,16.1,17.1,18.1],
            [13.148,13.764,14.441,15.264,16.172,17.074,18.052],[13.144,13.759,14.437,15.262,16.173,17.079,18.065],
            [13.140,13.756,14.434,15.260,16.175,17.086,18.080],[13.138,13.754,14.432,15.260,16.179,17.095,18.096],
            [13.137,13.752,14.432,15.262,16.184,17.106,18.114],[13.137,13.752,14.432,15.264,16.191,17.118,18.134],
            [13.138,13.753,14.434,15.268,16.198,17.131,18.156],[13.140,13.755,14.437,15.274,16.208,17.146,18.180],
            [13.143,13.758,14.441,15.280,16.218,17.163,18.205],[13.146,13.762,14.446,15.288,16.230,17.181,18.232],
            [13.151,13.767,14.452,15.296,16.244,17.201,18.261],[13.157,13.773,14.459,15.306,16.258,17.221,18.291],
            [13.163,13.780,14.467,15.317,16.273,17.244,18.323],[13.170,13.787,14.476,15.328,16.290,17.267,18.356],
            [13.177,13.795,14.485,15.341,16.307,17.291,18.390],[13.185,13.804,14.495,15.354,16.326,17.317,18.426],
            [13.193,13.813,14.506,15.368,16.345,17.343,18.463],[13.202,13.823,14.518,15.382,16.365,17.370,18.501],
            [13.212,13.833,14.529,15.398,16.386,17.399,18.541],[13.222,13.843,14.542,15.414,16.407,17.428,18.582],
            [13.232,13.855,14.555,15.430,16.429,17.458,18.623],[13.242,13.866,14.569,15.447,16.452,17.489,18.666],
            [13.253,13.878,14.582,15.465,16.476,17.521,18.710],[13.265,13.891,14.597,15.483,16.500,17.554,18.756],
            [13.276,13.904,14.612,15.502,16.525,17.588,18.801],[13.288,13.917,14.627,15.521,16.550,17.622,18.848],
            [13.301,13.930,14.643,15.541,16.577,17.657,18.897],[13.313,13.944,14.659,15.561,16.603,17.692,18.945],
            [13.326,13.958,14.675,15.581,16.631,17.729,18.996],[13.339,13.972,14.692,15.602,16.658,17.766,19.047],
            [13.352,13.987,14.709,15.624,16.686,17.803,19.098],[13.365,14.002,14.726,15.646,16.715,17.842,19.151],
            [13.379,14.017,14.744,15.668,16.744,17.881,19.205],[13.393,14.033,14.762,15.690,16.774,17.921,19.259],
            [13.407,14.049,14.781,15.713,16.804,17.961,19.315],[13.422,14.065,14.799,15.737,16.835,18.002,19.371],
            [13.436,14.081,14.819,15.761,16.867,18.044,19.428],[13.451,14.098,14.838,15.785,16.898,18.086,19.486],
            [13.466,14.115,14.858,15.809,16.931,18.129,19.545],[13.482,14.132,14.878,15.834,16.963,18.172,19.605],
            [13.497,14.149,14.898,15.860,16.996,18.216,19.666],[13.513,14.167,14.919,15.886,17.030,18.261,19.727],
            [13.529,14.185,14.940,15.912,17.064,18.306,19.789],[13.545,14.203,14.961,15.938,17.099,18.352,19.852],
            [13.562,14.222,14.983,15.965,17.134,18.399,19.916],[13.579,14.241,15.005,15.992,17.170,18.446,19.981],
            [13.596,14.260,15.028,16.020,17.206,18.493,20.046],[13.614,14.280,15.051,16.049,17.243,18.542,20.112],
            [13.632,14.300,15.074,16.078,17.280,18.591,20.180],[13.650,14.321,15.098,16.108,17.319,18.641,20.248],
            [13.669,14.343,15.123,16.138,17.357,18.692,20.317],[13.689,14.364,15.149,16.169,17.397,18.744,20.388],
            [13.708,14.387,15.175,16.201,17.438,18.797,20.459],[13.729,14.410,15.201,16.233,17.479,18.850,20.531],
            [13.750,14.433,15.228,16.266,17.521,18.905,20.605],[13.771,14.458,15.256,16.300,17.564,18.960,20.679],
            [13.794,14.483,15.285,16.335,17.608,19.016,20.754],[13.816,14.508,15.314,16.370,17.652,19.073,20.830],
            [13.840,14.534,15.344,16.406,17.697,19.130,20.907],[13.863,14.561,15.375,16.443,17.743,19.189,20.985],
            [13.888,14.588,15.406,16.481,17.790,19.248,21.063],[13.913,14.616,15.438,16.519,17.837,19.308,21.142],
            [13.938,14.644,15.471,16.558,17.886,19.369,21.223],[13.964,14.673,15.504,16.597,17.935,19.431,21.304],
            [13.990,14.703,15.538,16.638,17.984,19.493,21.385],[14.017,14.733,15.572,16.679,18.035,19.556,21.468],
            [14.045,14.764,15.607,16.720,18.086,19.620,21.551],[14.073,14.796,15.643,16.763,18.138,19.685,21.635],
            [14.102,14.828,15.679,16.806,18.191,19.750,21.720],[14.131,14.860,15.717,16.850,18.244,19.816,21.805],
            [14.161,14.893,15.754,16.894,18.298,19.883,21.891],[14.191,14.927,15.793,16.939,18.353,19.950,21.977],
            [14.222,14.962,15.832,16.985,18.408,20.018,22.064],[14.253,14.996,15.871,17.031,18.464,20.087,22.151],
            [14.285,15.032,15.911,17.078,18.521,20.156,22.239],[14.317,15.068,15.952,17.126,18.578,20.226,22.327],
            [14.350,15.105,15.993,17.175,18.636,20.296,22.416],[14.383,15.142,16.035,17.224,18.695,20.367,22.505],
            [14.417,15.179,16.078,17.273,18.754,20.439,22.595],[14.452,15.218,16.122,17.324,18.815,20.512,22.685],
            [14.487,15.257,16.166,17.375,18.875,20.585,22.775],[14.523,15.297,16.211,17.427,18.937,20.658,22.866],
            [14.559,15.337,16.256,17.480,19.000,20.733,22.958],[14.596,15.378,16.302,17.533,19.063,20.808,23.050],
            [14.634,15.420,16.349,17.588,19.127,20.884,23.142],[14.672,15.463,16.397,17.643,19.191,20.960,23.235],
            [14.711,15.506,16.446,17.698,19.257,21.037,23.328],[14.751,15.550,16.495,17.755,19.323,21.115,23.422],
            [14.791,15.594,16.545,17.812,19.390,21.194,23.516],[14.831,15.640,16.595,17.870,19.457,21.273,23.610],
            [14.873,15.685,16.646,17.929,19.526,21.352,23.705],[14.915,15.732,16.698,17.989,19.595,21.433,23.800],
            [14.957,15.779,16.751,18.049,19.665,21.513,23.895],[15.000,15.827,16.804,18.110,19.735,21.595,23.991],
            [15.044,15.875,16.858,18.171,19.806,21.676,24.086],[15.087,15.923,16.912,18.233,19.877,21.759,24.182],
            [15.132,15.973,16.967,18.296,19.949,21.841,24.278],[15.177,16.023,17.023,18.359,20.022,21.924,24.373],
            [15.222,16.073,17.079,18.422,20.095,22.008,24.470],[15.268,16.123,17.135,18.486,20.168,22.091,24.565],
            [15.313,16.174,17.192,18.550,20.241,22.174,24.660],[15.360,16.225,17.248,18.615,20.315,22.258,24.755],
            [15.406,16.276,17.306,18.680,20.389,22.341,24.850],[15.452,16.328,17.363,18.744,20.463,22.425,24.944],
            [15.499,16.379,17.420,18.810,20.537,22.508,25.037],[15.545,16.431,17.478,18.875,20.611,22.591,25.131],
            [15.592,16.483,17.535,18.940,20.685,22.674,25.223],[15.639,16.534,17.593,19.005,20.758,22.757,25.315],
            [15.685,16.586,17.651,19.070,20.832,22.839,25.406],[15.731,16.638,17.708,19.135,20.906,22.921,25.496],
            [15.778,16.689,17.766,19.200,20.979,23.003,25.586],[15.824,16.741,17.823,19.265,21.052,23.084,25.674],
            [15.870,16.792,17.880,19.329,21.125,23.164,25.762],[15.916,16.843,17.937,19.394,21.197,23.244,25.849],
            [15.961,16.894,17.994,19.458,21.269,23.324,25.935],[16.007,16.944,18.051,19.522,21.341,23.403,26.021],
            [16.052,16.995,18.107,19.585,21.413,23.482,26.105],[16.097,17.045,18.163,19.649,21.484,23.560,26.189],
            [16.142,17.095,18.219,19.712,21.554,23.637,26.271],[16.186,17.145,18.275,19.774,21.625,23.714,26.352],
            [16.230,17.194,18.330,19.837,21.694,23.790,26.433],[16.274,17.243,18.385,19.899,21.764,23.865,26.513],
            [16.318,17.292,18.439,19.960,21.832,23.940,26.592],[16.361,17.340,18.494,20.022,21.901,24.014,26.670],
            [16.404,17.389,18.548,20.082,21.969,24.088,26.747],[16.446,17.436,18.601,20.143,22.036,24.161,26.823],
            [16.488,17.484,18.654,20.203,22.103,24.233,26.897],[16.530,17.531,18.707,20.262,22.169,24.304,26.971],
            [16.571,17.577,18.759,20.321,22.235,24.375,27.044],[16.612,17.623,18.811,20.380,22.300,24.445,27.116],
            [16.652,17.669,18.862,20.438,22.364,24.514,27.188],[16.692,17.714,18.913,20.495,22.428,24.582,27.258],
            [16.732,17.759,18.964,20.552,22.491,24.650,27.326],[16.770,17.803,19.014,20.608,22.554,24.717,27.395],
            [16.809,17.847,19.063,20.664,22.616,24.783,27.462],[16.847,17.890,19.112,20.720,22.677,24.849,27.528],
            [16.884,17.933,19.161,20.774,22.738,24.913,27.593],[16.921,17.975,19.208,20.829,22.798,24.977,27.657],
            [16.958,18.017,19.256,20.882,22.857,25.040,27.720],[16.994,18.058,19.303,20.936,22.916,25.102,27.782],
            [17.029,18.099,19.349,20.988,22.974,25.164,27.844],[17.064,18.139,19.395,21.040,23.032,25.225,27.904],
            [17.098,18.179,19.440,21.091,23.088,25.284,27.963],[17.132,18.218,19.485,21.142,23.145,25.344,28.021],
            [17.165,18.256,19.529,21.192,23.200,25.402,28.079],[17.198,18.295,19.573,21.242,23.255,25.460,28.135],
            [17.231,18.332,19.616,21.291,23.309,25.516,28.190],[17.262,18.369,19.659,21.340,23.363,25.572,28.245],
            [17.293,18.406,19.701,21.388,23.416,25.628,28.299],[17.324,18.442,19.742,21.435,23.468,25.683,28.352],
            [17.354,18.477,19.783,21.482,23.520,25.736,28.403],[17.383,18.512,19.823,21.528,23.571,25.789,28.454],
            [17.412,18.547,19.863,21.574,23.621,25.842,28.504],[17.441,18.581,19.903,21.619,23.670,25.893,28.552],
            [17.469,18.614,19.942,21.664,23.720,25.943,28.600],[17.496,18.647,19.980,21.708,23.768,25.993,28.648],
            [17.523,18.679,20.018,21.751,23.815,26.042,28.693],[17.549,18.710,20.055,21.794,23.862,26.091,28.738],
            [17.575,18.742,20.091,21.836,23.909,26.138,28.782],[17.600,18.772,20.127,21.877,23.954,26.185,28.826],
            [17.624,18.802,20.163,21.918,23.999,26.230,28.868],[17.648,18.831,20.197,21.958,24.043,26.276,28.910],
            [17.671,18.860,20.232,21.998,24.087,26.320,28.950],[17.694,18.889,20.265,22.037,24.130,26.364,28.990],
            [17.716,18.916,20.299,22.076,24.172,26.406,29.028],[17.738,18.943,20.331,22.114,24.214,26.449,29.067],
            [17.759,18.970,20.363,22.151,24.255,26.490,29.103],[17.779,18.996,20.395,22.188,24.295,26.531,29.140],]

    bmigirls_m = [[11.2,11.8,12.5,13.3,14.2,15.0,15.9],[12.1,12.9,13.6,14.6,15.5,16.4,17.3],
            [13.2,14.0,14.8,15.8,16.8,17.8,18.8],[13.7,14.5,15.4,16.4,17.4,18.4,19.4],
            [14.0,14.8,15.7,16.7,17.7,18.8,19.8],[14.2,15.0,15.8,16.8,17.9,18.9,20.0],
            [14.3,15.1,15.9,16.9,18.0,19.0,20.1],[14.3,15.1,15.9,16.9,18.0,19.0,20.1],
            [14.3,15.0,15.9,16.8,17.9,18.9,20.0],[14.2,15.0,15.8,16.7,17.8,18.8,19.9],
            [14.1,14.9,15.7,16.6,17.7,18.7,19.7],[14.0,14.8,15.5,16.5,17.5,18.5,19.6],
            [13.9,14.6,15.4,16.4,17.4,18.4,19.4],[13.8,14.5,15.3,16.2,17.2,18.2,19.2],
            [13.7,14.4,15.2,16.1,17.1,18.1,19.1],[13.7,14.3,15.1,16.0,17.0,17.9,19.0],
            [13.6,14.3,15.0,15.9,16.9,17.8,18.8],[13.5,14.2,14.9,15.8,16.8,17.7,18.7],
            [13.4,14.1,14.8,15.7,16.7,17.6,18.6],[13.4,14.1,14.8,15.7,16.6,17.5,18.5],
            [13.3,14.0,14.7,15.6,16.5,17.5,18.5],[13.3,14.0,14.7,15.5,16.5,17.4,18.4],
            [13.3,13.9,14.6,15.5,16.4,17.3,18.3],[13.2,13.9,14.6,15.4,16.4,17.3,18.3],
            [13.2,13.9,14.6,15.4,16.3,17.3,18.2],[13.4,14.1,14.8,15.7,16.6,17.5,18.5],
            [13.4,14.1,14.8,15.6,16.6,17.5,18.5],[13.4,14.0,14.8,15.6,16.5,17.4,18.4],
            [13.4,14.0,14.7,15.6,16.5,17.4,18.4],[13.4,14.0,14.7,15.6,16.5,17.4,18.4],
            [13.3,14.0,14.7,15.5,16.5,17.4,18.3],[13.3,14.0,14.7,15.5,16.4,17.3,18.3],
            [13.3,13.9,14.6,15.5,16.4,17.3,18.3],[13.3,13.9,14.6,15.5,16.4,17.3,18.3],
            [13.2,13.9,14.6,15.4,16.4,17.3,18.2],[13.2,13.9,14.6,15.4,16.3,17.3,18.2],
            [13.2,13.8,14.5,15.4,16.3,17.2,18.2],[13.2,13.8,14.5,15.4,16.3,17.2,18.2],
            [13.2,13.8,14.5,15.4,16.3,17.2,18.2],[13.1,13.8,14.5,15.3,16.3,17.2,18.2],
            [13.1,13.8,14.5,15.3,16.3,17.2,18.2],[13.1,13.7,14.5,15.3,16.3,17.2,18.2],
            [13.1,13.7,14.4,15.3,16.3,17.2,18.2],[13.0,13.7,14.4,15.3,16.3,17.2,18.2],
            [13.0,13.7,14.4,15.3,16.3,17.2,18.2],[13.0,13.7,14.4,15.3,16.3,17.2,18.3],
            [13.0,13.7,14.4,15.3,16.3,17.2,18.3],[13.0,13.6,14.4,15.3,16.3,17.2,18.3],
            [12.9,13.6,14.4,15.3,16.3,17.2,18.3],[12.9,13.6,14.4,15.3,16.3,17.2,18.3],
            [12.9,13.6,14.3,15.3,16.3,17.3,18.3],[12.9,13.6,14.3,15.3,16.3,17.3,18.4],
            [12.9,13.6,14.3,15.3,16.3,17.3,18.4],[12.9,13.6,14.3,15.3,16.3,17.3,18.4],
            [12.9,13.6,14.3,15.3,16.3,17.3,18.4],[12.9,13.5,14.3,15.3,16.3,17.3,18.4],
            [12.8,13.5,14.3,15.3,16.3,17.3,18.5],[12.8,13.5,14.3,15.3,16.3,17.4,18.5],
            [12.8,13.5,14.3,15.3,16.3,17.4,18.5],[12.8,13.5,14.3,15.3,16.3,17.4,18.5],
            [12.8,13.5,14.3,15.3,16.3,17.4,18.6],
            [12.874,13.550,14.306,15.244,16.306,17.388,18.598],[12.868,13.544,14.301,15.243,16.311,17.402,18.624],
            [12.861,13.538,14.298,15.243,16.317,17.416,18.650],[12.855,13.533,14.294,15.244,16.324,17.431,18.677],
            [12.850,13.529,14.292,15.245,16.331,17.447,18.705],[12.845,13.525,14.290,15.246,16.339,17.463,18.734],
            [12.841,13.521,14.288,15.249,16.347,17.481,18.764],[12.837,13.518,14.287,15.252,16.357,17.499,18.795],
            [12.834,13.516,14.287,15.255,16.367,17.518,18.827],[12.831,13.514,14.287,15.259,16.377,17.537,18.860],
            [12.829,13.513,14.288,15.264,16.388,17.558,18.894],[12.828,13.513,14.290,15.270,16.401,17.579,18.929],
            [12.827,13.513,14.292,15.276,16.414,17.601,18.966],[12.826,13.514,14.295,15.283,16.427,17.625,19.003],
            [12.827,13.516,14.299,15.291,16.442,17.649,19.042],[12.828,13.518,14.303,15.300,16.458,17.674,19.081],
            [12.830,13.521,14.309,15.310,16.475,17.701,19.123],[12.832,13.525,14.315,15.320,16.492,17.728,19.165],
            [12.836,13.530,14.322,15.331,16.511,17.757,19.209],[12.840,13.535,14.330,15.344,16.530,17.787,19.254],
            [12.845,13.542,14.339,15.357,16.551,17.818,19.300],[12.851,13.549,14.349,15.372,16.573,17.850,19.348],
            [12.857,13.557,14.360,15.387,16.596,17.883,19.397],[12.865,13.566,14.371,15.404,16.620,17.918,19.448],
            [12.873,13.576,14.384,15.421,16.645,17.954,19.501],[12.882,13.587,14.398,15.440,16.671,17.991,19.554],
            [12.892,13.599,14.412,15.459,16.699,18.030,19.609],[12.903,13.611,14.428,15.480,16.727,18.069,19.666],
            [12.915,13.625,14.444,15.501,16.757,18.110,19.723],[12.927,13.639,14.462,15.524,16.788,18.152,19.783],
            [12.940,13.655,14.480,15.548,16.819,18.195,19.843],[12.954,13.671,14.499,15.572,16.852,18.240,19.905],
            [12.969,13.688,14.520,15.598,16.887,18.286,19.969],[12.984,13.706,14.541,15.625,16.922,18.333,20.034],
            [13.001,13.724,14.563,15.652,16.958,18.381,20.100],[13.018,13.744,14.586,15.681,16.995,18.430,20.167],
            [13.036,13.764,14.610,15.711,17.034,18.480,20.235],[13.055,13.786,14.635,15.742,17.073,18.532,20.305],
            [13.075,13.808,14.661,15.773,17.114,18.585,20.376],[13.095,13.831,14.687,15.806,17.156,18.639,20.449],
            [13.116,13.854,14.715,15.839,17.198,18.693,20.522],[13.137,13.879,14.743,15.874,17.242,18.749,20.597],
            [13.159,13.904,14.772,15.909,17.286,18.806,20.672],[13.182,13.930,14.802,15.945,17.331,18.864,20.748],
            [13.206,13.956,14.832,15.982,17.377,18.922,20.826],[13.230,13.983,14.864,16.019,17.424,18.982,20.904],
            [13.254,14.011,14.895,16.058,17.472,19.042,20.983],[13.279,14.039,14.928,16.096,17.520,19.102,21.062],
            [13.305,14.067,14.960,16.136,17.569,19.164,21.142],[13.331,14.097,14.994,16.176,17.618,19.226,21.223],
            [13.357,14.126,15.028,16.217,17.669,19.289,21.304],[13.384,14.156,15.063,16.258,17.720,19.352,21.386],
            [13.411,14.187,15.098,16.300,17.771,19.416,21.468],[13.439,14.218,15.134,16.343,17.823,19.481,21.551],
            [13.467,14.250,15.170,16.386,17.876,19.546,21.635],[13.496,14.283,15.207,16.430,17.930,19.612,21.719],
            [13.525,14.316,15.245,16.475,17.984,19.679,21.804],[13.555,14.349,15.283,16.520,18.039,19.746,21.889],
            [13.585,14.384,15.323,16.566,18.096,19.815,21.976],[13.616,14.418,15.362,16.613,18.152,19.884,22.063],
            [13.648,14.454,15.403,16.661,18.210,19.954,22.151],[13.681,14.491,15.445,16.710,18.269,20.025,22.239],
            [13.714,14.528,15.487,16.760,18.328,20.097,22.328],[13.747,14.566,15.530,16.810,18.389,20.170,22.418],
            [13.782,14.604,15.574,16.861,18.450,20.244,22.509],[13.817,14.644,15.619,16.914,18.512,20.318,22.601],
            [13.852,14.684,15.664,16.967,18.575,20.394,22.693],[13.889,14.724,15.710,17.021,18.640,20.470,22.786],
            [13.926,14.766,15.758,17.076,18.705,20.547,22.880],[13.964,14.809,15.806,17.132,18.771,20.626,22.975],
            [14.002,14.852,15.854,17.188,18.838,20.705,23.070],[14.041,14.896,15.904,17.246,18.906,20.785,23.167],
            [14.081,14.940,15.955,17.304,18.974,20.866,23.264],[14.122,14.986,16.006,17.364,19.044,20.948,23.361],
            [14.163,15.032,16.058,17.424,19.114,21.030,23.459],[14.205,15.078,16.110,17.485,19.186,21.113,23.558],
            [14.247,15.126,16.164,17.546,19.258,21.197,23.658],[14.290,15.174,16.218,17.609,19.331,21.282,23.758],
            [14.333,15.222,16.273,17.672,19.404,21.368,23.858],[14.377,15.271,16.328,17.736,19.478,21.454,23.959],
            [14.422,15.321,16.384,17.800,19.553,21.540,24.061],[14.467,15.371,16.441,17.865,19.629,21.628,24.162],
            [14.512,15.422,16.498,17.931,19.705,21.715,24.264],[14.558,15.473,16.555,17.997,19.781,21.803,24.366],
            [14.604,15.524,16.613,18.063,19.858,21.892,24.469],[14.650,15.576,16.671,18.130,19.935,21.980,24.571],
            [14.696,15.628,16.730,18.197,20.012,22.069,24.673],[14.743,15.680,16.788,18.264,20.090,22.157,24.775],
            [14.790,15.733,16.847,18.331,20.167,22.246,24.876],[14.836,15.785,16.906,18.399,20.245,22.335,24.978],
            [14.883,15.837,16.965,18.466,20.323,22.423,25.079],[14.930,15.889,17.024,18.533,20.400,22.511,25.179],
            [14.976,15.942,17.082,18.601,20.477,22.599,25.279],[15.023,15.994,17.141,18.668,20.555,22.687,25.378],
            [15.069,16.046,17.200,18.735,20.631,22.774,25.477],[15.115,16.097,17.258,18.801,20.708,22.860,25.574],
            [15.161,16.149,17.316,18.868,20.784,22.946,25.671],[15.207,16.200,17.373,18.934,20.859,23.032,25.767],
            [15.252,16.251,17.431,18.999,20.934,23.116,25.862],[15.297,16.301,17.488,19.064,21.009,23.201,25.956],
            [15.341,16.351,17.544,19.129,21.083,23.284,26.050],[15.386,16.401,17.600,19.193,21.156,23.367,26.141],
            [15.429,16.451,17.656,19.257,21.229,23.448,26.232],[15.472,16.499,17.711,19.320,21.301,23.529,26.322],
            [15.515,16.547,17.765,19.382,21.372,23.609,26.410],[15.557,16.595,17.819,19.444,21.443,23.688,26.497],
            [15.599,16.642,17.872,19.504,21.512,23.765,26.583],[15.640,16.688,17.925,19.565,21.581,23.842,26.667],
            [15.680,16.734,17.977,19.624,21.648,23.918,26.750],[15.720,16.779,18.028,19.682,21.715,23.992,26.832],
            [15.759,16.823,18.078,19.740,21.781,24.065,26.912],[15.797,16.867,18.127,19.797,21.845,24.137,26.991],
            [15.834,16.909,18.176,19.852,21.909,24.208,27.067],[15.871,16.951,18.223,19.907,21.971,24.277,27.143],
            [15.907,16.992,18.270,19.961,22.032,24.345,27.217],[15.942,17.033,18.316,20.013,22.092,24.411,27.288],
            [15.976,17.072,18.361,20.065,22.151,24.477,27.359],[16.010,17.110,18.404,20.115,22.208,24.540,27.427],
            [16.042,17.147,18.447,20.164,22.264,24.602,27.494],[16.074,17.184,18.489,20.212,22.319,24.663,27.559],
            [16.105,17.219,18.529,20.260,22.373,24.722,27.623],[16.135,17.254,18.569,20.305,22.425,24.779,27.684],
            [16.164,17.287,18.608,20.350,22.476,24.836,27.744],[16.192,17.320,18.645,20.393,22.525,24.890,27.802],
            [16.219,17.352,18.682,20.436,22.573,24.943,27.858],[16.245,17.382,18.717,20.477,22.620,24.995,27.913],
            [16.270,17.412,18.752,20.517,22.666,25.045,27.966],[16.295,17.441,18.785,20.556,22.710,25.094,28.017],
            [16.319,17.469,18.818,20.594,22.754,25.141,28.066],[16.342,17.496,18.849,20.631,22.795,25.187,28.114],
            [16.363,17.522,18.880,20.666,22.836,25.231,28.160],[16.384,17.547,18.909,20.701,22.876,25.274,28.205],
            [16.405,17.571,18.938,20.734,22.914,25.316,28.248],[16.424,17.595,18.966,20.767,22.951,25.356,28.289],
            [16.443,17.617,18.992,20.798,22.987,25.395,28.329],[16.461,17.639,19.018,20.829,23.021,25.433,28.367],
            [16.478,17.660,19.043,20.858,23.055,25.469,28.404],[16.494,17.679,19.067,20.886,23.087,25.504,28.439],
            [16.509,17.699,19.090,20.914,23.119,25.538,28.473],[16.524,17.717,19.112,20.940,23.149,25.570,28.505],
            [16.538,17.734,19.133,20.966,23.178,25.601,28.536],[16.551,17.751,19.154,20.990,23.206,25.631,28.566],
            [16.564,17.767,19.173,21.014,23.233,25.660,28.594],[16.576,17.783,19.193,21.037,23.259,25.688,28.620],
            [16.587,17.797,19.211,21.059,23.285,25.715,28.646],[16.597,17.811,19.228,21.080,23.309,25.741,28.672],
            [16.607,17.825,19.245,21.101,23.333,25.766,28.695],[16.617,17.838,19.262,21.121,23.355,25.790,28.717],
            [16.626,17.850,19.277,21.140,23.378,25.813,28.739],[16.635,17.862,19.292,21.159,23.399,25.836,28.760],
            [16.643,17.873,19.307,21.177,23.420,25.857,28.780],[16.650,17.884,19.321,21.194,23.440,25.878,28.799],
            [16.658,17.895,19.335,21.212,23.460,25.899,28.817],[16.665,17.905,19.348,21.228,23.479,25.919,28.835],
            [16.671,17.915,19.361,21.244,23.498,25.938,28.852],[16.678,17.924,19.374,21.260,23.516,25.957,28.868],
            [16.683,17.933,19.386,21.276,23.534,25.975,28.884],[16.689,17.942,19.398,21.291,23.551,25.993,28.899],
            [16.694,17.950,19.410,21.306,23.568,26.010,28.915],[16.700,17.959,19.421,21.320,23.585,26.027,28.929],
            [16.705,17.967,19.432,21.334,23.601,26.043,28.942],[16.709,17.975,19.443,21.348,23.617,26.059,28.956],
            [16.714,17.982,19.454,21.362,23.633,26.076,28.969],[16.718,17.990,19.464,21.375,23.648,26.091,28.982],
            [16.722,17.997,19.475,21.388,23.663,26.106,28.995],[16.726,18.004,19.485,21.401,23.678,26.121,29.007],
            [16.730,18.011,19.495,21.414,23.693,26.136,29.019],[16.734,18.017,19.504,21.427,23.707,26.151,29.030],]
    
    
    hcboys_w = [[32.1,32.8,33.6,34.5,35.3,36.1,36.9],[32.9,33.6,34.3,35.2,36.0,36.7,37.5],
            [33.7,34.4,35.1,35.9,36.7,37.4,38.1],[34.3,35.0,35.7,36.5,37.3,38.0,38.7],
            [34.9,35.6,36.3,37.1,37.9,38.6,39.3],[35.4,36.1,36.8,37.6,38.4,39.1,39.8],
            [35.9,36.6,37.3,38.1,38.8,39.6,40.3],[36.3,37.0,37.7,38.5,39.3,40.0,40.7],
            [36.7,36.9,37.7,38.9,39.7,40.4,41.1],[37.0,37.7,38.4,39.2,40.0,40.7,41.4],
            [37.4,38.1,38.8,39.6,40.4,41.1,41.8],[37.7,38.4,39.1,39.9,40.7,41.4,42.1],
            [38.0,38.7,39.4,40.2,41.0,41.7,42.4]]

    hcgirls_w = [[31.7,32.4,33.1,33.9,34.7,35.4,36.1],[32.4,33.1,33.8,34.6,35.3,36.0,36.7],
             [33.1,33.8,34.5,35.2,36.0,36.7,37.4],[33.7,34.4,35.1,35.8,36.6,37.3,38.0],
             [34.2,34.9,35.6,36.4,37.2,37.9,38.6],[34.6,35.3,36.1,36.8,37.6,38.4,39.1],
             [35.0,35.7,36.5,37.3,38.1,38.8,39.5],[35.4,36.1,36.9,37.7,38.5,39.2,39.9],
             [35.7,36.5,37.2,38.0,38.8,39.6,40.3],[36.1,36.8,37.5,38.4,38.4,39.9,40.6],
             [36.4,37.1,37.8,38.7,39.5,40.2,41.0],[36.7,37.4,38.1,39.0,39.8,40.5,41.3],
             [36.9,37.7,38.4,39.3,40.1,40.8,41.6]]

    hcboys_m = [[32.1,32.8,33.6,34.5,35.3,36.1,36.9],[35.1,35.8,36.5,37.3,38.1,38.8,39.5],
            [36.9,37.6,38.3,39.1,39.9,40.6,41.3],[38.3,39.0,39.7,40.5,41.3,42.0,42.7],
            [39.4,40.1,40.8,41.6,42.4,43.2,43.9],[40.3,41.0,41.7,42.6,43.4,44.1,44.8],
            [41.0,41.8,42.5,43.3,44.2,44.9,45.6],[41.7,42.4,43.1,44.0,44.8,45.6,46.3],
            [42.2,42.9,43.7,44.5,45.4,46.1,46.9],[42.6,43.4,44.2,45.0,45.8,46.6,47.4],
            [43.0,43.8,44.6,45.4,46.3,47.0,47.8],[43.4,44.1,44.9,45.8,46.6,47.4,48.2],
            [43.6,44.4,45.1,46.0,46.9,47.7,48.4],[43.9,44.6,45.4,46.3,47.2,47.9,48.7],
            [44.1,44.9,45.6,46.5,47.4,48.2,49.0],[44.3,45.1,45.9,46.7,47.6,48.4,49.2],
            [44.5,45.3,46.1,46.9,47.8,48.6,49.4],[44.7,45.4,46.2,47.1,48.0,48.8,49.6],
            [44.8,45.6,46.4,47.3,48.2,49.0,49.8],[45.0,45.8,46.6,47.5,48.4,49.2,50.0],
            [45.1,45.9,46.7,47.6,48.5,49.3,50.2],[45.3,46.1,46.9,47.8,48.7,49.5,50.3],
            [45.4,46.2,47.0,47.9,48.8,49.7,50.5],[45.5,46.3,47.2,48.1,49.0,49.8,50.6],]

    hcgirls_m = [[31.7,32.4,33.1,33.9,34.7,35.4,36.1],[34.3,35.0,35.8,36.5,37.3,38.0,38.8],
             [36.0,36.7,37.4,38.3,39.1,39.8,40.5],[37.2,37.9,38.7,39.5,40.4,41.1,41.9],
             [38.2,39.0,39.7,40.6,41.4,42.2,43.0],[39.0,39.8,40.6,41.5,42.3,43.1,43.9],
             [39.7,40.5,41.3,42.2,43.1,43.9,44.6],[40.4,41.1,41.9,42.8,43.7,44.5,45.3],
             [40.9,41.7,42.5,43.4,44.3,45.1,45.9],[41.3,42.1,42.9,43.8,44.7,45.5,46.3],
             [41.7,42.5,43.3,44.2,45.1,46.0,46.8],[42.0,42.9,43.7,44.6,45.5,46.3,47.1],
             [42.3,43.1,43.9,44.8,45.8,46.6,47.4],[42.6,43.4,44.2,45.1,46.0,46.9,47.7],
             [42.8,43.6,44.4,45.4,46.3,47.1,47.9],[43.0,43.8,44.7,45.6,46.5,47.4,48.2],
             [43.2,44.0,44.9,45.8,46.7,47.6,48.4],[43.4,44.2,45.1,46.0,46.9,47.8,48.6],
             [43.6,44.4,45.3,46.2,47.1,48.0,48.9],[43.8,44.6,45.4,46.4,47.3,48.1,49.0],
             [43.9,44.7,45.6,46.5,47.5,48.3,49.1],[44.1,44.9,45.7,46.7,47.6,48.5,49.3],
             [44.2,45.1,45.9,46.8,47.8,48.6,49.4],[44.4,45.2,46.0,47.0,47.9,48.8,49.6],]


    
    percentiles = ["less than P3","P3 y P10","P10 y P25","P25 y P50","P50 y P75","P75 y P90","P90 y P97","greater than P97"]

    exact_percentiles = ["P3","P10","P25","P50","P75","P90","P97"]
    
    adult_bmi_percentiles = ["Under Weight", "Normal", "Overweight", "Obesity GI", "Obesity GII", "Obesity GIII"]
    
    w_perc = fields.Char ('Weight Percentile')
    
    h_perc = fields.Char ('Height Percentile')
    
    bmi_perc = fields.Char ('BMI Percentile')
    
    cp_perc = fields.Char ('CP Percentile')
    
    
# for calculated the Weight Percentile
    
    @fields.depends('weight','patient','wboys_m','wboys_w','wgirls_m','wgirls_w','percentiles','evaluation_start','patient_ambulatory_care')
    def on_change_with_w_perc(self):

        age_w = 0
        age_m = 0
        correction = 0
        born_week = 37
        pool = Pool()
        Newborn = pool.get('gnuhealth.newborn')
        newborn = Newborn.search([('patient','=',self.patient)])
        if self.patient and newborn:
            born_week = int(newborn[0].born_week)
        
        if self.patient and self.patient.name.dob and born_week:
            correction = 37- int(born_week)
            delta = relativedelta(self.evaluation_start, self.patient.name.dob) 
            age_w = int(delta.years*365.2425 + delta.months*30.5 + delta.days)//7-correction
            age_m = int(delta.years*12 + delta.months)-(correction//4)

  
                 
        if self.patient and age_w < 0 and self.weight and age_w:
            w_perc = "Before term"
            return w_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >=0 and age_w <= 12 and self.weight:
            if self.weight in self.wboys_w[age_w]:
                w_perc = self.percentiles_exacto[self.wboys_w[age_w].index(self.weight)]
                return w_perc
            else:
                aux = self.wboys_w[age_w]+ [float(self.weight)]
                aux.sort()
                w_perc = self.percentiles[aux.index(self.weight)]
                return w_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >= 13 and age_m and age_m <= 120 and self.weight:
            if self.weight in self.wboys_m[age_m]:
                w_perc = self.percentiles_exacto[self.wboys_m[age_m].index(self.weight)]
                return w_perc
            else:
                aux = self.wboys_m[age_m]+ [float(self.weight)]
                aux.sort()
                w_perc = self.percentiles[aux.index(self.weight)]
                return w_perc
        elif self.patient and self.patient.name.gender =="m" and age_m > 120 and self.weight and age_m:
            w_perc = "-"
            return w_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >=0 and age_w <= 12 and self.weight:
            if self.weight in self.wgirls_w[age_w]:
                w_perc = self.percentiles_exacto[self.wgirls_w[age_w].index(self.weight)]
                return w_perc
            else:
                aux = self.wgirls_w[age_w]+ [float(self.weight)]
                aux.sort()
                w_perc = self.percentiles[aux.index(self.weight)]
                return w_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >= 13 and age_m and age_m <= 120 and self.weight:
            if self.weight in self.wgirls_m[age_m]:
                w_perc = self.percentiles_exacto[self.wgirls_m[age_m].index(self.weight)]
                return w_perc
            else:
                aux = self.wgirls_m[age_m]+ [float(self.weight)]
                aux.sort()
                w_perc = self.percentiles[aux.index(self.weight)]
                return w_perc
        elif self.patient and self.patient.name.gender =="f" and age_m > 120 and self.weight and age_m:
            w_perc = "-"
            return w_perc


# for calculated the Height Percentile

    @fields.depends('height','patient','hboys_m','hboys_w','hgirls_m','hgirls_w','percentiles','evaluation_start','patient_ambulatory_care')
    def on_change_with_h_perc(self):

        age_w = 0
        age_m = 0
        correction = 0
        born_week = 37
        pool = Pool()
        Newborn = pool.get('gnuhealth.newborn')
        newborn = Newborn.search([('patient','=',self.patient)])
        if self.patient and newborn:
            born_week = int(newborn[0].born_week)
        
        if self.patient and self.patient.name.dob and born_week:
            correction = 37- int(born_week)
            delta = relativedelta(self.evaluation_start, self.patient.name.dob) 
            age_w = (int(delta.years*365.2425 + delta.months*30.5 + delta.days)//7) - correction
            age_m = int(delta.years*12 + delta.months)-(correction//4)
   
                 
        if self.patient and age_w < 0 and self.height and age_w:
            h_perc = "Before term"
            return h_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >=0 and age_w <=12 and self.height:
            if self.height in self.hboys_w[age_w]:
                h_perc = self.percentiles_exacto[self.hboys_w[age_w].index(self.height)]
                return h_perc
            else:
                aux = self.hboys_w[age_w]+ [float(self.height)]
                aux.sort()
                h_perc = self.percentiles[aux.index(self.height)]
                return h_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >= 13 and age_m and age_m <= 228 and self.height:
            if self.height in self.hboys_m[age_m]:
                h_perc = self.percentiles_exacto[self.hboys_m[age_m].index(self.height)]
                return h_perc
            else:
                aux = self.hboys_m[age_m]+ [float(self.height)]
                aux.sort()
                h_perc = self.percentiles[aux.index(self.height)]
                return h_perc
        elif self.patient and self.patient.name.gender =="m" and age_m > 228 and self.height and age_m:
            h_perc = "-"
            return h_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >=0 and age_w <= 12 and self.height:
            if self.height in self.hgirls_w[age_w]:
                h_perc = self.percentiles_exacto[self.hgirls_w[age_w].index(self.height)]
                return h_perc
            else:
                aux = self.hgirls_w[age_w]+ [float(self.height)]
                aux.sort()
                h_perc = self.percentiles[aux.index(self.height)]
                return h_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >= 13 and age_m and age_m <=228 and self.height:
            if self.height in self.hgirls_m[age_m]:
                h_perc = self.percentiles_exacto[self.hgirls_m[age_m].index(self.height)]
                return h_perc
            else:
                aux = self.hgirls_m[age_m]+ [float(self.height)]
                aux.sort()
                h_perc = self.percentiles[aux.index(self.height)]
                return h_perc
        elif self.patient and self.patient.name.gender =="f" and age_m > 228 and self.height and age_m:
            h_perc = "-"
            return h_perc
        
# for calculated the BMI Percentile
        
    @fields.depends('weight','height','patient','bmiboys_m','bmiboys_w','bmigirls_m','bmigirls_w','percentiles','evaluation_start','patient_ambulatory_care')
    def on_change_with_bmi_perc(self):

        born_week = 37
        pool = Pool()
        Newborn = pool.get('gnuhealth.newborn')
        newborn = Newborn.search([('patient','=',self.patient)])
        if self.patient and newborn:
            born_week = int(newborn[0].born_week)
        
        age_w = 0
        age_m = 0
        bmi = 0.0
        correction = 0
        
        
        if self.patient and self.patient.name.dob and born_week:
            correction = 37- int(born_week)
            delta = relativedelta(self.evaluation_start, self.patient.name.dob) 
            age_w = (int(delta.years*365.2425 + delta.months*30.5 + delta.days)//7) - correction
            age_m = int(delta.years*12 + delta.months)-(correction//4)
            
        if self.weight and self.height:
            bmi = float(self.weight) / pow((float(self.height)/100),2)

            
        if self.patient and age_w < 0 and self.weight and self.height and age_w:
            bmi_perc = "Before term"
            return bmi_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >=0 and age_w <= 12 and self.weight and self.height:
            if bmi in self.bmiboys_w[age_w]:
                bmi_perc = self.percentiles_exacto[self.bmiboys_w[age_w].index(bmi)]
                return bmi_perc
            else:
                aux = self.bmiboys_w[age_w]+ [bmi]
                aux.sort()
                bmi_perc = self.percentiles[aux.index(bmi)]
                return bmi_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >= 13 and age_m and age_m <= 228 and self.weight and self.height:
            if bmi in self.bmiboys_m[age_m]:
                bmi_perc = self.percentiles_exacto[self.bmiboys_m[age_m].index(bmi)]
                return bmi_perc
            else:
                aux = self.bmiboys_m[age_m]+ [bmi]
                aux.sort()
                bmi_perc = self.percentiles[aux.index(bmi)]
                return bmi_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >=0 and age_w <=  12 and self.weight and self.height:
            if bmi in self.bmigirls_w[age_w]:
                bmi_perc = self.percentiles_exacto[self.bmigirls_w[age_w].index(bmi)]
                return bmi_perc
            else:
                aux = self.bmigirls_w[age_w]+ [bmi]
                aux.sort()
                bmi_perc = self.percentiles[aux.index(bmi)]
                return bmi_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >= 13 and age_m and age_m <= 228 and self.weight and self.height:
            if bmi in self.bmigirls_m[age_m]:
                bmi_perc = self.percentiles_exacto[self.bmigirls_m[age_m].index(bmi)]
                return bmi_perc
            else:
                aux = self.bmigirls_m[age_m]+ [bmi]
                aux.sort()
                bmi_perc = self.percentiles[aux.index(bmi)]
                return bmi_perc
        elif self.patient and age_m > 228 and self.weight and age_m and self.height:
            if bmi <18.5:
                return self.adult_bmi_percentiles[0]
            elif bmi >=18.5 and bmi <25:
                return self.adult_bmi_percentiles[1]
            elif bmi >=25 and bmi <30:
                return self.adult_bmi_percentiles[2]
            elif bmi >=30 and bmi <35:
                return self.adult_bmi_percentiles[3]
            elif bmi >=30 and bmi <40:
                return self.adult_bmi_percentiles[4]
            else:
                return self.adult_bmi_percentiles[5]

        

# for calculated the Cephalic Perimeter Percentile
        
    @fields.depends('head_circumference','patient','hcboys_m','hcboys_w','hcgirls_m','hcgirls_w','percentiles','evaluation_start','patient_ambulatory_care')
    def on_change_with_cp_perc(self):

        born_week = 37
        pool = Pool()
        Newborn = pool.get('gnuhealth.newborn')
        newborn = Newborn.search([('patient','=',self.patient)])
        if self.patient and newborn:
            born_week = int(newborn[0].born_week)
        
        age_w = 0
        age_m = 0
        cp = 0.0
        correction = 0
        
        
        if self.patient and self.patient.name.dob and born_week:
            correction = 37- int(born_week)
            delta = relativedelta(self.evaluation_start, self.patient.name.dob) 
            age_w = (int(delta.years*365.2425 + delta.months*30.5 + delta.days)//7) - correction
            age_m = int(delta.years*12 + delta.months)-(correction//4)
            
        if self.head_circumference:
            cp = float(self.head_circumference)

            
        if self.patient and age_w < 0 and self.head_circumference and age_w:
            cp_perc = "Before term"
            return cp_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >=0 and age_w <= 12 and self.head_circumference:
            if cp in self.hcboys_w[age_w]:
                cp_perc = self.percentiles_exacto[self.hcboys_w[age_w].index(cp)]
                return cp_perc
            else:
                aux = self.hcboys_w[age_w]+ [cp]
                aux.sort()
                cp_perc = self.percentiles[aux.index(cp)]
                return cp_perc
        elif self.patient and self.patient.name.gender == "m" and age_w >= 13 and age_m and age_m < 24 and self.head_circumference:
            if cp in self.hcboys_m[age_m]:
                cp_perc = self.percentiles_exacto[self.hcboys_m[age_m].index(cp)]
                return cp_perc
            else:
                aux = self.hcboys_m[age_m]+ [cp]
                aux.sort()
                cp_perc = self.percentiles[aux.index(cp)]
                return cp_perc
        elif self.patient and self.patient.name.gender =="m" and age_m >=24 and self.head_circumference and age_m:
            cp_perc = "Age Out Range"
            return cp_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >=0 and age_w <=  12 and self.head_circumference:
            if cp in self.hcgirls_w[age_w]:
                cp_perc = self.percentiles_exacto[self.hcgirls_w[age_w].index(cp)]
                return cp_perc
            else:
                aux = self.hcgirls_w[age_w]+ [cp]
                aux.sort()
                cp_perc = self.percentiles[aux.index(cp)]
                return cp_perc
        elif self.patient and self.patient.name.gender == "f" and age_w >= 13 and age_m and age_m < 24 and self.head_circumference:
            if cp in self.bmigirls_m[age_m]:
                cp_perc = self.percentiles_exacto[self.hcgirls_m[age_m].index(cp)]
                return cp_perc
            else:
                aux = self.hcgirls_m[age_m]+ [cp]
                aux.sort
                cp_perc = self.percentiles[aux.index(cp)]
                return cp_perc
        elif self.patient and self.patient.name.gender =="f" and age_m >=24 and self.head_circumference and age_m:
            cp_perc = "Age Out Range"
            return cp_perc

    antro_resume = fields.Function(fields.Text('Antropometria'),
                                 'get_antro_resume')
    
    def get_antro_resume(self, name):
        pool = Pool()    
        
        weight = str(self.weight) or ''
        height= str(self.height) or ''
        bmi= str(self.bmi) or ''
        head_circumference = str(self.head_circumference) or ''
        
        w_perc = self.w_perc or ''
        h_perc = self.h_perc or ''
        bmi_perc = self.bmi_perc or ''
        cp_perc = self.cp_perc or ''
        
        if self.patient.age_float >5:
            antro_resume = "Peso: "+ weight + " [Kg]" + "\n" + "Altura: " + height + " [cm]" + "\n" + "IMC: " + bmi
        else:
            antro_resume = "Peso: "+ weight + " [Kg] " + " --> " + w_perc + "\n" + "Altura: " + height + " [cm] " +" --> " + h_perc + "\n" + "IMC: " + bmi + " --> "+ bmi_perc + "\n" + "Per. Cef.: " + head_circumference + " [cm] " + " --> " + cp_perc 
        
        return antro_resume
